import{S as Sa,i as La,s as Ha,e as s,k as m,w as $,t as n,M as Wa,c as r,d as o,m as f,a as i,x as D,h as a,b as d,N as Ua,G as e,g as p,y,q as T,o as A,B as E,v as Ka,L as Kn}from"../../chunks/vendor-hf-doc-builder.js";import{T as Oa}from"../../chunks/Tip-hf-doc-builder.js";import{D as $t}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Vn}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Dt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Un}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Va(P){let h,v,_,u,b;return u=new Vn({props:{code:`from transformers import DinatConfig, DinatModel

# Initializing a Dinat shi-labs/dinat-mini-in1k-224 style configuration
configuration = DinatConfig()

# Initializing a model (with random weights) from the shi-labs/dinat-mini-in1k-224 style configuration
model = DinatModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DinatConfig, DinatModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a Dinat shi-labs/dinat-mini-in1k-224 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = DinatConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the shi-labs/dinat-mini-in1k-224 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DinatModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){h=s("p"),v=n("Example:"),_=m(),$(u.$$.fragment)},l(l){h=r(l,"P",{});var g=i(h);v=a(g,"Example:"),g.forEach(o),_=f(l),D(u.$$.fragment,l)},m(l,g){p(l,h,g),e(h,v),p(l,_,g),y(u,l,g),b=!0},p:Kn,i(l){b||(T(u.$$.fragment,l),b=!0)},o(l){A(u.$$.fragment,l),b=!1},d(l){l&&o(h),l&&o(_),E(u,l)}}}function Qa(P){let h,v,_,u,b;return{c(){h=s("p"),v=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),u=n("Module"),b=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){h=r(l,"P",{});var g=i(h);v=a(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(g,"CODE",{});var j=i(_);u=a(j,"Module"),j.forEach(o),b=a(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(l,g){p(l,h,g),e(h,v),e(h,_),e(_,u),e(h,b)},d(l){l&&o(h)}}}function Ra(P){let h,v,_,u,b;return u=new Vn({props:{code:`from transformers import AutoImageProcessor, DinatModel
import torch
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

feature_extractor = AutoImageProcessor.from_pretrained("shi-labs/dinat-mini-in1k-224")
model = DinatModel.from_pretrained("shi-labs/dinat-mini-in1k-224")

inputs = feature_extractor(image, return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DinatModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;shi-labs/dinat-mini-in1k-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DinatModel.from_pretrained(<span class="hljs-string">&quot;shi-labs/dinat-mini-in1k-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">7</span>, <span class="hljs-number">7</span>, <span class="hljs-number">512</span>]`}}),{c(){h=s("p"),v=n("Example:"),_=m(),$(u.$$.fragment)},l(l){h=r(l,"P",{});var g=i(h);v=a(g,"Example:"),g.forEach(o),_=f(l),D(u.$$.fragment,l)},m(l,g){p(l,h,g),e(h,v),p(l,_,g),y(u,l,g),b=!0},p:Kn,i(l){b||(T(u.$$.fragment,l),b=!0)},o(l){A(u.$$.fragment,l),b=!1},d(l){l&&o(h),l&&o(_),E(u,l)}}}function Ba(P){let h,v,_,u,b;return{c(){h=s("p"),v=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=s("code"),u=n("Module"),b=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){h=r(l,"P",{});var g=i(h);v=a(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(g,"CODE",{});var j=i(_);u=a(j,"Module"),j.forEach(o),b=a(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(o)},m(l,g){p(l,h,g),e(h,v),e(h,_),e(_,u),e(h,b)},d(l){l&&o(h)}}}function Ga(P){let h,v,_,u,b;return u=new Vn({props:{code:`from transformers import AutoImageProcessor, DinatForImageClassification
import torch
from datasets import load_dataset

dataset = load_dataset("huggingface/cats-image")
image = dataset["test"]["image"][0]

feature_extractor = AutoImageProcessor.from_pretrained("shi-labs/dinat-mini-in1k-224")
model = DinatForImageClassification.from_pretrained("shi-labs/dinat-mini-in1k-224")

inputs = feature_extractor(image, return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

# model predicts one of the 1000 ImageNet classes
predicted_label = logits.argmax(-1).item()
print(model.config.id2label[predicted_label])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DinatForImageClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;huggingface/cats-image&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = dataset[<span class="hljs-string">&quot;test&quot;</span>][<span class="hljs-string">&quot;image&quot;</span>][<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;shi-labs/dinat-mini-in1k-224&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DinatForImageClassification.from_pretrained(<span class="hljs-string">&quot;shi-labs/dinat-mini-in1k-224&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 1000 ImageNet classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = logits.argmax(-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.config.id2label[predicted_label])
tabby, tabby cat`}}),{c(){h=s("p"),v=n("Example:"),_=m(),$(u.$$.fragment)},l(l){h=r(l,"P",{});var g=i(h);v=a(g,"Example:"),g.forEach(o),_=f(l),D(u.$$.fragment,l)},m(l,g){p(l,h,g),e(h,v),p(l,_,g),y(u,l,g),b=!0},p:Kn,i(l){b||(T(u.$$.fragment,l),b=!0)},o(l){A(u.$$.fragment,l),b=!1},d(l){l&&o(h),l&&o(_),E(u,l)}}}function Xa(P){let h,v,_,u,b,l,g,j,Zt,yt,F,V,Ye,he,eo,Je,to,Tt,Q,oo,pe,no,ao,At,R,so,je,ro,io,Et,Me,lo,Ct,qe,Ze,co,xt,ze,ho,kt,B,me,po,Fe,mo,fo,uo,w,go,et,_o,bo,tt,vo,wo,ot,$o,Do,nt,yo,To,at,Ao,Eo,st,Co,xo,rt,ko,Po,Pt,Oe,Io,It,G,M,No,fe,jo,Mo,ue,qo,zo,it,Fo,Oo,So,lt,Lo,Nt,X,Qn,jt,Y,Ho,Se,Wo,Uo,Mt,z,Ko,ge,Vo,Qo,_e,Ro,Bo,qt,O,J,dt,be,Go,ct,Xo,zt,x,ve,Yo,S,Jo,Le,Zo,en,we,tn,on,nn,L,an,He,sn,rn,We,ln,dn,cn,Z,Ft,H,ee,ht,$e,hn,pt,pn,Ot,q,De,mn,ye,fn,Te,un,gn,_n,I,Ae,bn,W,vn,Ue,wn,$n,mt,Dn,yn,Tn,te,An,oe,St,U,ne,ft,Ee,En,ut,Cn,Lt,k,Ce,xn,gt,kn,Pn,xe,In,ke,Nn,jn,Mn,N,Pe,qn,K,zn,Ke,Fn,On,_t,Sn,Ln,Hn,ae,Wn,se,Ht;return l=new Dt({}),he=new Dt({}),be=new Dt({}),ve=new $t({props:{name:"class transformers.DinatConfig",anchor:"transformers.DinatConfig",parameters:[{name:"patch_size",val:" = 4"},{name:"num_channels",val:" = 3"},{name:"embed_dim",val:" = 64"},{name:"depths",val:" = [3, 4, 6, 5]"},{name:"num_heads",val:" = [2, 4, 8, 16]"},{name:"kernel_size",val:" = 7"},{name:"dilations",val:" = [[1, 8, 1], [1, 4, 1, 4], [1, 2, 1, 2, 1, 2], [1, 1, 1, 1, 1]]"},{name:"mlp_ratio",val:" = 3.0"},{name:"qkv_bias",val:" = True"},{name:"hidden_dropout_prob",val:" = 0.0"},{name:"attention_probs_dropout_prob",val:" = 0.0"},{name:"drop_path_rate",val:" = 0.1"},{name:"hidden_act",val:" = 'gelu'"},{name:"patch_norm",val:" = True"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DinatConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
The size (resolution) of each patch. NOTE: Only patch size of 4 is supported at the moment.`,name:"patch_size"},{anchor:"transformers.DinatConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.DinatConfig.embed_dim",description:`<strong>embed_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Dimensionality of patch embedding.`,name:"embed_dim"},{anchor:"transformers.DinatConfig.depths",description:`<strong>depths</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[2, 2, 6, 2]</code>) &#x2014;
Number of layers in each level of the encoder.`,name:"depths"},{anchor:"transformers.DinatConfig.num_heads",description:`<strong>num_heads</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[3, 6, 12, 24]</code>) &#x2014;
Number of attention heads in each layer of the Transformer encoder.`,name:"num_heads"},{anchor:"transformers.DinatConfig.kernel_size",description:`<strong>kernel_size</strong> (<code>int</code>, <em>optional</em>, defaults to 7) &#x2014;
Neighborhood Attention kernel size.`,name:"kernel_size"},{anchor:"transformers.DinatConfig.dilations",description:`<strong>dilations</strong> (<code>List[List[int]]</code>, <em>optional</em>, defaults to <code>[[1, 8, 1], [1, 4, 1, 4], [1, 2, 1, 2, 1, 2], [1, 1, 1, 1, 1]]</code>) &#x2014;
Dilation value of each NA layer in the Transformer encoder.`,name:"dilations"},{anchor:"transformers.DinatConfig.mlp_ratio",description:`<strong>mlp_ratio</strong> (<code>float</code>, <em>optional</em>, defaults to 3.0) &#x2014;
Ratio of MLP hidden dimensionality to embedding dimensionality.`,name:"mlp_ratio"},{anchor:"transformers.DinatConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not a learnable bias should be added to the queries, keys and values.`,name:"qkv_bias"},{anchor:"transformers.DinatConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probability for all fully connected layers in the embeddings and encoder.`,name:"hidden_dropout_prob"},{anchor:"transformers.DinatConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.DinatConfig.drop_path_rate",description:`<strong>drop_path_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Stochastic depth rate.`,name:"drop_path_rate"},{anchor:"transformers.DinatConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder. If string, <code>&quot;gelu&quot;</code>, <code>&quot;relu&quot;</code>,
<code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.DinatConfig.patch_norm",description:`<strong>patch_norm</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to add layer normalization after patch embedding.`,name:"patch_norm"},{anchor:"transformers.DinatConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.DinatConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-12) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/dinat/configuration_dinat.py#L29"}}),Z=new Un({props:{anchor:"transformers.DinatConfig.example",$$slots:{default:[Va]},$$scope:{ctx:P}}}),$e=new Dt({}),De=new $t({props:{name:"class transformers.DinatModel",anchor:"transformers.DinatModel",parameters:[{name:"config",val:""},{name:"add_pooling_layer",val:" = True"}],parametersDescription:[{anchor:"transformers.DinatModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/dinat#transformers.DinatConfig">DinatConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/dinat/modeling_dinat.py#L683"}}),Ae=new $t({props:{name:"forward",anchor:"transformers.DinatModel.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.DinatModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<code>AutoImageProcessor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.DinatModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DinatModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DinatModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/dinat/modeling_dinat.py#L713",returnDescription:`
<p>A <code>transformers.models.dinat.modeling_dinat.DinatModelOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/dinat#transformers.DinatConfig"
>DinatConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>pooler_output</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, hidden_size)</code>, <em>optional</em>, returned when <code>add_pooling_layer=True</code> is passed) \u2014 Average pooling of the last layer hidden-state.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each stage) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>reshaped_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, hidden_size, height, width)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs reshaped to
include the spatial dimensions.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.models.dinat.modeling_dinat.DinatModelOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),te=new Oa({props:{$$slots:{default:[Qa]},$$scope:{ctx:P}}}),oe=new Un({props:{anchor:"transformers.DinatModel.forward.example",$$slots:{default:[Ra]},$$scope:{ctx:P}}}),Ee=new Dt({}),Ce=new $t({props:{name:"class transformers.DinatForImageClassification",anchor:"transformers.DinatForImageClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.DinatForImageClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/dinat#transformers.DinatConfig">DinatConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/dinat/modeling_dinat.py#L776"}}),Pe=new $t({props:{name:"forward",anchor:"transformers.DinatForImageClassification.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.DinatForImageClassification.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See
<code>AutoImageProcessor.__call__()</code> for details.`,name:"pixel_values"},{anchor:"transformers.DinatForImageClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DinatForImageClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DinatForImageClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DinatForImageClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/dinat/modeling_dinat.py#L793",returnDescription:`
<p>A <code>transformers.models.dinat.modeling_dinat.DinatImageClassifierOutput</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/dinat#transformers.DinatConfig"
>DinatConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each stage) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
<li>
<p><strong>reshaped_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each stage) of
shape <code>(batch_size, hidden_size, height, width)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs reshaped to
include the spatial dimensions.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.models.dinat.modeling_dinat.DinatImageClassifierOutput</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ae=new Oa({props:{$$slots:{default:[Ba]},$$scope:{ctx:P}}}),se=new Un({props:{anchor:"transformers.DinatForImageClassification.forward.example",$$slots:{default:[Ga]},$$scope:{ctx:P}}}),{c(){h=s("meta"),v=m(),_=s("h1"),u=s("a"),b=s("span"),$(l.$$.fragment),g=m(),j=s("span"),Zt=n("Dilated Neighborhood Attention Transformer"),yt=m(),F=s("h2"),V=s("a"),Ye=s("span"),$(he.$$.fragment),eo=m(),Je=s("span"),to=n("Overview"),Tt=m(),Q=s("p"),oo=n("DiNAT was proposed in "),pe=s("a"),no=n("Dilated Neighborhood Attention Transformer"),ao=n(`
by Ali Hassani and Humphrey Shi.`),At=m(),R=s("p"),so=n("It extends "),je=s("a"),ro=n("NAT"),io=n(` by adding a Dilated Neighborhood Attention pattern to capture global context,
and shows significant performance improvements over it.`),Et=m(),Me=s("p"),lo=n("The abstract from the paper is the following:"),Ct=m(),qe=s("p"),Ze=s("em"),co=n(`Transformers are quickly becoming one of the most heavily applied deep learning architectures across modalities,
domains, and tasks. In vision, on top of ongoing efforts into plain transformers, hierarchical transformers have
also gained significant attention, thanks to their performance and easy integration into existing frameworks.
These models typically employ localized attention mechanisms, such as the sliding-window Neighborhood Attention (NA)
or Swin Transformer\u2019s Shifted Window Self Attention. While effective at reducing self attention\u2019s quadratic complexity,
local attention weakens two of the most desirable properties of self attention: long range inter-dependency modeling,
and global receptive field. In this paper, we introduce Dilated Neighborhood Attention (DiNA), a natural, flexible and
efficient extension to NA that can capture more global context and expand receptive fields exponentially at no
additional cost. NA\u2019s local attention and DiNA\u2019s sparse global attention complement each other, and therefore we
introduce Dilated Neighborhood Attention Transformer (DiNAT), a new hierarchical vision transformer built upon both.
DiNAT variants enjoy significant improvements over strong baselines such as NAT, Swin, and ConvNeXt.
Our large model is faster and ahead of its Swin counterpart by 1.5% box AP in COCO object detection,
1.3% mask AP in COCO instance segmentation, and 1.1% mIoU in ADE20K semantic segmentation.
Paired with new frameworks, our large variant is the new state of the art panoptic segmentation model on COCO (58.2 PQ)
and ADE20K (48.5 PQ), and instance segmentation model on Cityscapes (44.5 AP) and ADE20K (35.4 AP) (no extra data).
It also matches the state of the art specialized semantic segmentation models on ADE20K (58.2 mIoU),
and ranks second on Cityscapes (84.5 mIoU) (no extra data).`),xt=m(),ze=s("p"),ho=n("Tips:"),kt=m(),B=s("ul"),me=s("li"),po=n("One can use the "),Fe=s("a"),mo=n("AutoImageProcessor"),fo=n(" API to prepare images for the model."),uo=m(),w=s("li"),go=n("DiNAT can be used as a "),et=s("em"),_o=n("backbone"),bo=n(". When "),tt=s("code"),vo=n("output_hidden_states = True"),wo=n(`,
it will output both `),ot=s("code"),$o=n("hidden_states"),Do=n(" and "),nt=s("code"),yo=n("reshaped_hidden_states"),To=n(". The "),at=s("code"),Ao=n("reshaped_hidden_states"),Eo=n(" have a shape of "),st=s("code"),Co=n("(batch, num_channels, height, width)"),xo=n(" rather than "),rt=s("code"),ko=n("(batch_size, height, width, num_channels)"),Po=n("."),Pt=m(),Oe=s("p"),Io=n("Notes:"),It=m(),G=s("ul"),M=s("li"),No=n("DiNAT depends on "),fe=s("a"),jo=n("NATTEN"),Mo=n(`\u2019s implementation of Neighborhood Attention and Dilated Neighborhood Attention.
You can install it with pre-built wheels for Linux by referring to `),ue=s("a"),qo=n("shi-labs.com/natten"),zo=n(", or build on your system by running "),it=s("code"),Fo=n("pip install natten"),Oo=n(`.
Note that the latter will likely take time to compile. NATTEN does not support Windows devices yet.`),So=m(),lt=s("li"),Lo=n("Patch size of 4 is only supported at the moment."),Nt=m(),X=s("img"),jt=m(),Y=s("small"),Ho=n(`Neighborhood Attention with different dilation values.
Taken from the `),Se=s("a"),Wo=n("original paper"),Uo=n("."),Mt=m(),z=s("p"),Ko=n("This model was contributed by "),ge=s("a"),Vo=n("Ali Hassani"),Qo=n(`.
The original code can be found `),_e=s("a"),Ro=n("here"),Bo=n("."),qt=m(),O=s("h2"),J=s("a"),dt=s("span"),$(be.$$.fragment),Go=m(),ct=s("span"),Xo=n("DinatConfig"),zt=m(),x=s("div"),$(ve.$$.fragment),Yo=m(),S=s("p"),Jo=n("This is the configuration class to store the configuration of a "),Le=s("a"),Zo=n("DinatModel"),en=n(`. It is used to instantiate a Dinat
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the Dinat
`),we=s("a"),tn=n("shi-labs/dinat-mini-in1k-224"),on=n(" architecture."),nn=m(),L=s("p"),an=n("Configuration objects inherit from "),He=s("a"),sn=n("PretrainedConfig"),rn=n(` and can be used to control the model outputs. Read the
documentation from `),We=s("a"),ln=n("PretrainedConfig"),dn=n(" for more information."),cn=m(),$(Z.$$.fragment),Ft=m(),H=s("h2"),ee=s("a"),ht=s("span"),$($e.$$.fragment),hn=m(),pt=s("span"),pn=n("DinatModel"),Ot=m(),q=s("div"),$(De.$$.fragment),mn=m(),ye=s("p"),fn=n(`The bare Dinat Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Te=s("a"),un=n("torch.nn.Module"),gn=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),_n=m(),I=s("div"),$(Ae.$$.fragment),bn=m(),W=s("p"),vn=n("The "),Ue=s("a"),wn=n("DinatModel"),$n=n(" forward method, overrides the "),mt=s("code"),Dn=n("__call__"),yn=n(" special method."),Tn=m(),$(te.$$.fragment),An=m(),$(oe.$$.fragment),St=m(),U=s("h2"),ne=s("a"),ft=s("span"),$(Ee.$$.fragment),En=m(),ut=s("span"),Cn=n("DinatForImageClassification"),Lt=m(),k=s("div"),$(Ce.$$.fragment),xn=m(),gt=s("p"),kn=n(`Dinat Model transformer with an image classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.`),Pn=m(),xe=s("p"),In=n("This model is a PyTorch "),ke=s("a"),Nn=n("torch.nn.Module"),jn=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Mn=m(),N=s("div"),$(Pe.$$.fragment),qn=m(),K=s("p"),zn=n("The "),Ke=s("a"),Fn=n("DinatForImageClassification"),On=n(" forward method, overrides the "),_t=s("code"),Sn=n("__call__"),Ln=n(" special method."),Hn=m(),$(ae.$$.fragment),Wn=m(),$(se.$$.fragment),this.h()},l(t){const c=Wa('[data-svelte="svelte-1phssyn"]',document.head);h=r(c,"META",{name:!0,content:!0}),c.forEach(o),v=f(t),_=r(t,"H1",{class:!0});var Ie=i(_);u=r(Ie,"A",{id:!0,class:!0,href:!0});var bt=i(u);b=r(bt,"SPAN",{});var vt=i(b);D(l.$$.fragment,vt),vt.forEach(o),bt.forEach(o),g=f(Ie),j=r(Ie,"SPAN",{});var wt=i(j);Zt=a(wt,"Dilated Neighborhood Attention Transformer"),wt.forEach(o),Ie.forEach(o),yt=f(t),F=r(t,"H2",{class:!0});var Ne=i(F);V=r(Ne,"A",{id:!0,class:!0,href:!0});var Rn=i(V);Ye=r(Rn,"SPAN",{});var Bn=i(Ye);D(he.$$.fragment,Bn),Bn.forEach(o),Rn.forEach(o),eo=f(Ne),Je=r(Ne,"SPAN",{});var Gn=i(Je);to=a(Gn,"Overview"),Gn.forEach(o),Ne.forEach(o),Tt=f(t),Q=r(t,"P",{});var Wt=i(Q);oo=a(Wt,"DiNAT was proposed in "),pe=r(Wt,"A",{href:!0,rel:!0});var Xn=i(pe);no=a(Xn,"Dilated Neighborhood Attention Transformer"),Xn.forEach(o),ao=a(Wt,`
by Ali Hassani and Humphrey Shi.`),Wt.forEach(o),At=f(t),R=r(t,"P",{});var Ut=i(R);so=a(Ut,"It extends "),je=r(Ut,"A",{href:!0});var Yn=i(je);ro=a(Yn,"NAT"),Yn.forEach(o),io=a(Ut,` by adding a Dilated Neighborhood Attention pattern to capture global context,
and shows significant performance improvements over it.`),Ut.forEach(o),Et=f(t),Me=r(t,"P",{});var Jn=i(Me);lo=a(Jn,"The abstract from the paper is the following:"),Jn.forEach(o),Ct=f(t),qe=r(t,"P",{});var Zn=i(qe);Ze=r(Zn,"EM",{});var ea=i(Ze);co=a(ea,`Transformers are quickly becoming one of the most heavily applied deep learning architectures across modalities,
domains, and tasks. In vision, on top of ongoing efforts into plain transformers, hierarchical transformers have
also gained significant attention, thanks to their performance and easy integration into existing frameworks.
These models typically employ localized attention mechanisms, such as the sliding-window Neighborhood Attention (NA)
or Swin Transformer\u2019s Shifted Window Self Attention. While effective at reducing self attention\u2019s quadratic complexity,
local attention weakens two of the most desirable properties of self attention: long range inter-dependency modeling,
and global receptive field. In this paper, we introduce Dilated Neighborhood Attention (DiNA), a natural, flexible and
efficient extension to NA that can capture more global context and expand receptive fields exponentially at no
additional cost. NA\u2019s local attention and DiNA\u2019s sparse global attention complement each other, and therefore we
introduce Dilated Neighborhood Attention Transformer (DiNAT), a new hierarchical vision transformer built upon both.
DiNAT variants enjoy significant improvements over strong baselines such as NAT, Swin, and ConvNeXt.
Our large model is faster and ahead of its Swin counterpart by 1.5% box AP in COCO object detection,
1.3% mask AP in COCO instance segmentation, and 1.1% mIoU in ADE20K semantic segmentation.
Paired with new frameworks, our large variant is the new state of the art panoptic segmentation model on COCO (58.2 PQ)
and ADE20K (48.5 PQ), and instance segmentation model on Cityscapes (44.5 AP) and ADE20K (35.4 AP) (no extra data).
It also matches the state of the art specialized semantic segmentation models on ADE20K (58.2 mIoU),
and ranks second on Cityscapes (84.5 mIoU) (no extra data).`),ea.forEach(o),Zn.forEach(o),xt=f(t),ze=r(t,"P",{});var ta=i(ze);ho=a(ta,"Tips:"),ta.forEach(o),kt=f(t),B=r(t,"UL",{});var Kt=i(B);me=r(Kt,"LI",{});var Vt=i(me);po=a(Vt,"One can use the "),Fe=r(Vt,"A",{href:!0});var oa=i(Fe);mo=a(oa,"AutoImageProcessor"),oa.forEach(o),fo=a(Vt," API to prepare images for the model."),Vt.forEach(o),uo=f(Kt),w=r(Kt,"LI",{});var C=i(w);go=a(C,"DiNAT can be used as a "),et=r(C,"EM",{});var na=i(et);_o=a(na,"backbone"),na.forEach(o),bo=a(C,". When "),tt=r(C,"CODE",{});var aa=i(tt);vo=a(aa,"output_hidden_states = True"),aa.forEach(o),wo=a(C,`,
it will output both `),ot=r(C,"CODE",{});var sa=i(ot);$o=a(sa,"hidden_states"),sa.forEach(o),Do=a(C," and "),nt=r(C,"CODE",{});var ra=i(nt);yo=a(ra,"reshaped_hidden_states"),ra.forEach(o),To=a(C,". The "),at=r(C,"CODE",{});var ia=i(at);Ao=a(ia,"reshaped_hidden_states"),ia.forEach(o),Eo=a(C," have a shape of "),st=r(C,"CODE",{});var la=i(st);Co=a(la,"(batch, num_channels, height, width)"),la.forEach(o),xo=a(C," rather than "),rt=r(C,"CODE",{});var da=i(rt);ko=a(da,"(batch_size, height, width, num_channels)"),da.forEach(o),Po=a(C,"."),C.forEach(o),Kt.forEach(o),Pt=f(t),Oe=r(t,"P",{});var ca=i(Oe);Io=a(ca,"Notes:"),ca.forEach(o),It=f(t),G=r(t,"UL",{});var Qt=i(G);M=r(Qt,"LI",{});var re=i(M);No=a(re,"DiNAT depends on "),fe=r(re,"A",{href:!0,rel:!0});var ha=i(fe);jo=a(ha,"NATTEN"),ha.forEach(o),Mo=a(re,`\u2019s implementation of Neighborhood Attention and Dilated Neighborhood Attention.
You can install it with pre-built wheels for Linux by referring to `),ue=r(re,"A",{href:!0,rel:!0});var pa=i(ue);qo=a(pa,"shi-labs.com/natten"),pa.forEach(o),zo=a(re,", or build on your system by running "),it=r(re,"CODE",{});var ma=i(it);Fo=a(ma,"pip install natten"),ma.forEach(o),Oo=a(re,`.
Note that the latter will likely take time to compile. NATTEN does not support Windows devices yet.`),re.forEach(o),So=f(Qt),lt=r(Qt,"LI",{});var fa=i(lt);Lo=a(fa,"Patch size of 4 is only supported at the moment."),fa.forEach(o),Qt.forEach(o),Nt=f(t),X=r(t,"IMG",{src:!0,alt:!0,width:!0}),jt=f(t),Y=r(t,"SMALL",{});var Rt=i(Y);Ho=a(Rt,`Neighborhood Attention with different dilation values.
Taken from the `),Se=r(Rt,"A",{href:!0});var ua=i(Se);Wo=a(ua,"original paper"),ua.forEach(o),Uo=a(Rt,"."),Rt.forEach(o),Mt=f(t),z=r(t,"P",{});var Ve=i(z);Ko=a(Ve,"This model was contributed by "),ge=r(Ve,"A",{href:!0,rel:!0});var ga=i(ge);Vo=a(ga,"Ali Hassani"),ga.forEach(o),Qo=a(Ve,`.
The original code can be found `),_e=r(Ve,"A",{href:!0,rel:!0});var _a=i(_e);Ro=a(_a,"here"),_a.forEach(o),Bo=a(Ve,"."),Ve.forEach(o),qt=f(t),O=r(t,"H2",{class:!0});var Bt=i(O);J=r(Bt,"A",{id:!0,class:!0,href:!0});var ba=i(J);dt=r(ba,"SPAN",{});var va=i(dt);D(be.$$.fragment,va),va.forEach(o),ba.forEach(o),Go=f(Bt),ct=r(Bt,"SPAN",{});var wa=i(ct);Xo=a(wa,"DinatConfig"),wa.forEach(o),Bt.forEach(o),zt=f(t),x=r(t,"DIV",{class:!0});var ie=i(x);D(ve.$$.fragment,ie),Yo=f(ie),S=r(ie,"P",{});var Qe=i(S);Jo=a(Qe,"This is the configuration class to store the configuration of a "),Le=r(Qe,"A",{href:!0});var $a=i(Le);Zo=a($a,"DinatModel"),$a.forEach(o),en=a(Qe,`. It is used to instantiate a Dinat
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the Dinat
`),we=r(Qe,"A",{href:!0,rel:!0});var Da=i(we);tn=a(Da,"shi-labs/dinat-mini-in1k-224"),Da.forEach(o),on=a(Qe," architecture."),Qe.forEach(o),nn=f(ie),L=r(ie,"P",{});var Re=i(L);an=a(Re,"Configuration objects inherit from "),He=r(Re,"A",{href:!0});var ya=i(He);sn=a(ya,"PretrainedConfig"),ya.forEach(o),rn=a(Re,` and can be used to control the model outputs. Read the
documentation from `),We=r(Re,"A",{href:!0});var Ta=i(We);ln=a(Ta,"PretrainedConfig"),Ta.forEach(o),dn=a(Re," for more information."),Re.forEach(o),cn=f(ie),D(Z.$$.fragment,ie),ie.forEach(o),Ft=f(t),H=r(t,"H2",{class:!0});var Gt=i(H);ee=r(Gt,"A",{id:!0,class:!0,href:!0});var Aa=i(ee);ht=r(Aa,"SPAN",{});var Ea=i(ht);D($e.$$.fragment,Ea),Ea.forEach(o),Aa.forEach(o),hn=f(Gt),pt=r(Gt,"SPAN",{});var Ca=i(pt);pn=a(Ca,"DinatModel"),Ca.forEach(o),Gt.forEach(o),Ot=f(t),q=r(t,"DIV",{class:!0});var Be=i(q);D(De.$$.fragment,Be),mn=f(Be),ye=r(Be,"P",{});var Xt=i(ye);fn=a(Xt,`The bare Dinat Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Te=r(Xt,"A",{href:!0,rel:!0});var xa=i(Te);un=a(xa,"torch.nn.Module"),xa.forEach(o),gn=a(Xt,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Xt.forEach(o),_n=f(Be),I=r(Be,"DIV",{class:!0});var le=i(I);D(Ae.$$.fragment,le),bn=f(le),W=r(le,"P",{});var Ge=i(W);vn=a(Ge,"The "),Ue=r(Ge,"A",{href:!0});var ka=i(Ue);wn=a(ka,"DinatModel"),ka.forEach(o),$n=a(Ge," forward method, overrides the "),mt=r(Ge,"CODE",{});var Pa=i(mt);Dn=a(Pa,"__call__"),Pa.forEach(o),yn=a(Ge," special method."),Ge.forEach(o),Tn=f(le),D(te.$$.fragment,le),An=f(le),D(oe.$$.fragment,le),le.forEach(o),Be.forEach(o),St=f(t),U=r(t,"H2",{class:!0});var Yt=i(U);ne=r(Yt,"A",{id:!0,class:!0,href:!0});var Ia=i(ne);ft=r(Ia,"SPAN",{});var Na=i(ft);D(Ee.$$.fragment,Na),Na.forEach(o),Ia.forEach(o),En=f(Yt),ut=r(Yt,"SPAN",{});var ja=i(ut);Cn=a(ja,"DinatForImageClassification"),ja.forEach(o),Yt.forEach(o),Lt=f(t),k=r(t,"DIV",{class:!0});var de=i(k);D(Ce.$$.fragment,de),xn=f(de),gt=r(de,"P",{});var Ma=i(gt);kn=a(Ma,`Dinat Model transformer with an image classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.`),Ma.forEach(o),Pn=f(de),xe=r(de,"P",{});var Jt=i(xe);In=a(Jt,"This model is a PyTorch "),ke=r(Jt,"A",{href:!0,rel:!0});var qa=i(ke);Nn=a(qa,"torch.nn.Module"),qa.forEach(o),jn=a(Jt,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Jt.forEach(o),Mn=f(de),N=r(de,"DIV",{class:!0});var ce=i(N);D(Pe.$$.fragment,ce),qn=f(ce),K=r(ce,"P",{});var Xe=i(K);zn=a(Xe,"The "),Ke=r(Xe,"A",{href:!0});var za=i(Ke);Fn=a(za,"DinatForImageClassification"),za.forEach(o),On=a(Xe," forward method, overrides the "),_t=r(Xe,"CODE",{});var Fa=i(_t);Sn=a(Fa,"__call__"),Fa.forEach(o),Ln=a(Xe," special method."),Xe.forEach(o),Hn=f(ce),D(ae.$$.fragment,ce),Wn=f(ce),D(se.$$.fragment,ce),ce.forEach(o),de.forEach(o),this.h()},h(){d(h,"name","hf:doc:metadata"),d(h,"content",JSON.stringify(Ya)),d(u,"id","dilated-neighborhood-attention-transformer"),d(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(u,"href","#dilated-neighborhood-attention-transformer"),d(_,"class","relative group"),d(V,"id","overview"),d(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(V,"href","#overview"),d(F,"class","relative group"),d(pe,"href","https://arxiv.org/abs/2209.15001"),d(pe,"rel","nofollow"),d(je,"href","nat"),d(Fe,"href","/docs/transformers/main/en/model_doc/auto#transformers.AutoImageProcessor"),d(fe,"href","https://github.com/SHI-Labs/NATTEN/"),d(fe,"rel","nofollow"),d(ue,"href","https://shi-labs.com/natten"),d(ue,"rel","nofollow"),Ua(X.src,Qn="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/dilated-neighborhood-attention-pattern.jpg")||d(X,"src",Qn),d(X,"alt","drawing"),d(X,"width","600"),d(Se,"href","https://arxiv.org/abs/2209.15001"),d(ge,"href","https://huggingface.co/alihassanijr"),d(ge,"rel","nofollow"),d(_e,"href","https://github.com/SHI-Labs/Neighborhood-Attention-Transformer"),d(_e,"rel","nofollow"),d(J,"id","transformers.DinatConfig"),d(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(J,"href","#transformers.DinatConfig"),d(O,"class","relative group"),d(Le,"href","/docs/transformers/main/en/model_doc/dinat#transformers.DinatModel"),d(we,"href","https://huggingface.co/shi-labs/dinat-mini-in1k-224"),d(we,"rel","nofollow"),d(He,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),d(We,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),d(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ee,"id","transformers.DinatModel"),d(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ee,"href","#transformers.DinatModel"),d(H,"class","relative group"),d(Te,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(Te,"rel","nofollow"),d(Ue,"href","/docs/transformers/main/en/model_doc/dinat#transformers.DinatModel"),d(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(ne,"id","transformers.DinatForImageClassification"),d(ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ne,"href","#transformers.DinatForImageClassification"),d(U,"class","relative group"),d(ke,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(ke,"rel","nofollow"),d(Ke,"href","/docs/transformers/main/en/model_doc/dinat#transformers.DinatForImageClassification"),d(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,c){e(document.head,h),p(t,v,c),p(t,_,c),e(_,u),e(u,b),y(l,b,null),e(_,g),e(_,j),e(j,Zt),p(t,yt,c),p(t,F,c),e(F,V),e(V,Ye),y(he,Ye,null),e(F,eo),e(F,Je),e(Je,to),p(t,Tt,c),p(t,Q,c),e(Q,oo),e(Q,pe),e(pe,no),e(Q,ao),p(t,At,c),p(t,R,c),e(R,so),e(R,je),e(je,ro),e(R,io),p(t,Et,c),p(t,Me,c),e(Me,lo),p(t,Ct,c),p(t,qe,c),e(qe,Ze),e(Ze,co),p(t,xt,c),p(t,ze,c),e(ze,ho),p(t,kt,c),p(t,B,c),e(B,me),e(me,po),e(me,Fe),e(Fe,mo),e(me,fo),e(B,uo),e(B,w),e(w,go),e(w,et),e(et,_o),e(w,bo),e(w,tt),e(tt,vo),e(w,wo),e(w,ot),e(ot,$o),e(w,Do),e(w,nt),e(nt,yo),e(w,To),e(w,at),e(at,Ao),e(w,Eo),e(w,st),e(st,Co),e(w,xo),e(w,rt),e(rt,ko),e(w,Po),p(t,Pt,c),p(t,Oe,c),e(Oe,Io),p(t,It,c),p(t,G,c),e(G,M),e(M,No),e(M,fe),e(fe,jo),e(M,Mo),e(M,ue),e(ue,qo),e(M,zo),e(M,it),e(it,Fo),e(M,Oo),e(G,So),e(G,lt),e(lt,Lo),p(t,Nt,c),p(t,X,c),p(t,jt,c),p(t,Y,c),e(Y,Ho),e(Y,Se),e(Se,Wo),e(Y,Uo),p(t,Mt,c),p(t,z,c),e(z,Ko),e(z,ge),e(ge,Vo),e(z,Qo),e(z,_e),e(_e,Ro),e(z,Bo),p(t,qt,c),p(t,O,c),e(O,J),e(J,dt),y(be,dt,null),e(O,Go),e(O,ct),e(ct,Xo),p(t,zt,c),p(t,x,c),y(ve,x,null),e(x,Yo),e(x,S),e(S,Jo),e(S,Le),e(Le,Zo),e(S,en),e(S,we),e(we,tn),e(S,on),e(x,nn),e(x,L),e(L,an),e(L,He),e(He,sn),e(L,rn),e(L,We),e(We,ln),e(L,dn),e(x,cn),y(Z,x,null),p(t,Ft,c),p(t,H,c),e(H,ee),e(ee,ht),y($e,ht,null),e(H,hn),e(H,pt),e(pt,pn),p(t,Ot,c),p(t,q,c),y(De,q,null),e(q,mn),e(q,ye),e(ye,fn),e(ye,Te),e(Te,un),e(ye,gn),e(q,_n),e(q,I),y(Ae,I,null),e(I,bn),e(I,W),e(W,vn),e(W,Ue),e(Ue,wn),e(W,$n),e(W,mt),e(mt,Dn),e(W,yn),e(I,Tn),y(te,I,null),e(I,An),y(oe,I,null),p(t,St,c),p(t,U,c),e(U,ne),e(ne,ft),y(Ee,ft,null),e(U,En),e(U,ut),e(ut,Cn),p(t,Lt,c),p(t,k,c),y(Ce,k,null),e(k,xn),e(k,gt),e(gt,kn),e(k,Pn),e(k,xe),e(xe,In),e(xe,ke),e(ke,Nn),e(xe,jn),e(k,Mn),e(k,N),y(Pe,N,null),e(N,qn),e(N,K),e(K,zn),e(K,Ke),e(Ke,Fn),e(K,On),e(K,_t),e(_t,Sn),e(K,Ln),e(N,Hn),y(ae,N,null),e(N,Wn),y(se,N,null),Ht=!0},p(t,[c]){const Ie={};c&2&&(Ie.$$scope={dirty:c,ctx:t}),Z.$set(Ie);const bt={};c&2&&(bt.$$scope={dirty:c,ctx:t}),te.$set(bt);const vt={};c&2&&(vt.$$scope={dirty:c,ctx:t}),oe.$set(vt);const wt={};c&2&&(wt.$$scope={dirty:c,ctx:t}),ae.$set(wt);const Ne={};c&2&&(Ne.$$scope={dirty:c,ctx:t}),se.$set(Ne)},i(t){Ht||(T(l.$$.fragment,t),T(he.$$.fragment,t),T(be.$$.fragment,t),T(ve.$$.fragment,t),T(Z.$$.fragment,t),T($e.$$.fragment,t),T(De.$$.fragment,t),T(Ae.$$.fragment,t),T(te.$$.fragment,t),T(oe.$$.fragment,t),T(Ee.$$.fragment,t),T(Ce.$$.fragment,t),T(Pe.$$.fragment,t),T(ae.$$.fragment,t),T(se.$$.fragment,t),Ht=!0)},o(t){A(l.$$.fragment,t),A(he.$$.fragment,t),A(be.$$.fragment,t),A(ve.$$.fragment,t),A(Z.$$.fragment,t),A($e.$$.fragment,t),A(De.$$.fragment,t),A(Ae.$$.fragment,t),A(te.$$.fragment,t),A(oe.$$.fragment,t),A(Ee.$$.fragment,t),A(Ce.$$.fragment,t),A(Pe.$$.fragment,t),A(ae.$$.fragment,t),A(se.$$.fragment,t),Ht=!1},d(t){o(h),t&&o(v),t&&o(_),E(l),t&&o(yt),t&&o(F),E(he),t&&o(Tt),t&&o(Q),t&&o(At),t&&o(R),t&&o(Et),t&&o(Me),t&&o(Ct),t&&o(qe),t&&o(xt),t&&o(ze),t&&o(kt),t&&o(B),t&&o(Pt),t&&o(Oe),t&&o(It),t&&o(G),t&&o(Nt),t&&o(X),t&&o(jt),t&&o(Y),t&&o(Mt),t&&o(z),t&&o(qt),t&&o(O),E(be),t&&o(zt),t&&o(x),E(ve),E(Z),t&&o(Ft),t&&o(H),E($e),t&&o(Ot),t&&o(q),E(De),E(Ae),E(te),E(oe),t&&o(St),t&&o(U),E(Ee),t&&o(Lt),t&&o(k),E(Ce),E(Pe),E(ae),E(se)}}}const Ya={local:"dilated-neighborhood-attention-transformer",sections:[{local:"overview",title:"Overview"},{local:"transformers.DinatConfig",title:"DinatConfig"},{local:"transformers.DinatModel",title:"DinatModel"},{local:"transformers.DinatForImageClassification",title:"DinatForImageClassification"}],title:"Dilated Neighborhood Attention Transformer"};function Ja(P){return Ka(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ss extends Sa{constructor(h){super();La(this,h,Ja,Xa,Ha,{})}}export{ss as default,Ya as metadata};
