import{S as h_,i as m_,s as p_,e as a,k as d,w as b,t as n,M as f_,c as s,d as t,m as c,a as i,x as v,h as r,b as l,G as e,g as p,y as D,q as y,o as w,B as x,v as u_,L as li}from"../../chunks/vendor-hf-doc-builder.js";import{T as di}from"../../chunks/Tip-hf-doc-builder.js";import{D as N}from"../../chunks/Docstring-hf-doc-builder.js";import{C as So}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as kt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ci}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function g_(z){let f,E,g,u,T;return u=new So({props:{code:`from transformers import DetrConfig, DetrModel

# Initializing a DETR facebook/detr-resnet-50 style configuration
configuration = DetrConfig()

# Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration
model = DetrModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a DETR facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = DetrConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){f=a("p"),E=n("Examples:"),g=d(),b(u.$$.fragment)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Examples:"),_.forEach(t),g=c(m),v(u.$$.fragment,m)},m(m,_){p(m,f,_),e(f,E),p(m,g,_),D(u,m,_),T=!0},p:li,i(m){T||(y(u.$$.fragment,m),T=!0)},o(m){w(u.$$.fragment,m),T=!1},d(m){m&&t(f),m&&t(g),x(u,m)}}}function __(z){let f,E;return{c(){f=a("p"),E=n(`NumPy arrays and PyTorch tensors are converted to PIL images when resizing, so the most efficient is to pass
PIL images.`)},l(g){f=s(g,"P",{});var u=i(f);E=r(u,`NumPy arrays and PyTorch tensors are converted to PIL images when resizing, so the most efficient is to pass
PIL images.`),u.forEach(t)},m(g,u){p(g,f,u),e(f,E)},d(g){g&&t(f)}}}function b_(z){let f,E,g,u,T;return{c(){f=a("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),u=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=s(_,"CODE",{});var U=i(g);u=r(U,"Module"),U.forEach(t),T=r(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(t)},m(m,_){p(m,f,_),e(f,E),e(f,g),e(g,u),e(f,T)},d(m){m&&t(f)}}}function v_(z){let f,E,g,u,T;return u=new So({props:{code:`from transformers import DetrFeatureExtractor, DetrModel
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

feature_extractor = DetrFeatureExtractor.from_pretrained("facebook/detr-resnet-50")
model = DetrModel.from_pretrained("facebook/detr-resnet-50")

# prepare image for the model
inputs = feature_extractor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# the last hidden states are the final query embeddings of the Transformer decoder
# these are of shape (batch_size, num_queries, hidden_size)
last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrFeatureExtractor, DetrModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = DetrFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the last hidden states are the final query embeddings of the Transformer decoder</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># these are of shape (batch_size, num_queries, hidden_size)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">100</span>, <span class="hljs-number">256</span>]`}}),{c(){f=a("p"),E=n("Examples:"),g=d(),b(u.$$.fragment)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Examples:"),_.forEach(t),g=c(m),v(u.$$.fragment,m)},m(m,_){p(m,f,_),e(f,E),p(m,g,_),D(u,m,_),T=!0},p:li,i(m){T||(y(u.$$.fragment,m),T=!0)},o(m){w(u.$$.fragment,m),T=!1},d(m){m&&t(f),m&&t(g),x(u,m)}}}function D_(z){let f,E,g,u,T;return{c(){f=a("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),u=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=s(_,"CODE",{});var U=i(g);u=r(U,"Module"),U.forEach(t),T=r(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(t)},m(m,_){p(m,f,_),e(f,E),e(f,g),e(g,u),e(f,T)},d(m){m&&t(f)}}}function y_(z){let f,E,g,u,T;return u=new So({props:{code:`from transformers import DetrFeatureExtractor, DetrForObjectDetection
import torch
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

feature_extractor = DetrFeatureExtractor.from_pretrained("facebook/detr-resnet-50")
model = DetrForObjectDetection.from_pretrained("facebook/detr-resnet-50")

inputs = feature_extractor(images=image, return_tensors="pt")
outputs = model(**inputs)

# convert outputs (bounding boxes and class logits) to COCO API
target_sizes = torch.tensor([image.size[::-1]])
results = feature_extractor.post_process_object_detection(
    outputs, threshold=0.9, target_sizes=target_sizes
)[0]

for score, label, box in zip(results["scores"], results["labels"], results["boxes"]):
    box = [round(i, 2) for i in box.tolist()]
    print(
        f"Detected {model.config.id2label[label.item()]} with confidence "
        f"{round(score.item(), 3)} at location {box}"
    )`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrFeatureExtractor, DetrForObjectDetection
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = DetrFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># convert outputs (bounding boxes and class logits) to COCO API</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_sizes = torch.tensor([image.size[::-<span class="hljs-number">1</span>]])
<span class="hljs-meta">&gt;&gt;&gt; </span>results = feature_extractor.post_process_object_detection(
<span class="hljs-meta">... </span>    outputs, threshold=<span class="hljs-number">0.9</span>, target_sizes=target_sizes
<span class="hljs-meta">... </span>)[<span class="hljs-number">0</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> score, label, box <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(results[<span class="hljs-string">&quot;scores&quot;</span>], results[<span class="hljs-string">&quot;labels&quot;</span>], results[<span class="hljs-string">&quot;boxes&quot;</span>]):
<span class="hljs-meta">... </span>    box = [<span class="hljs-built_in">round</span>(i, <span class="hljs-number">2</span>) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> box.tolist()]
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;Detected <span class="hljs-subst">{model.config.id2label[label.item()]}</span> with confidence &quot;</span>
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;<span class="hljs-subst">{<span class="hljs-built_in">round</span>(score.item(), <span class="hljs-number">3</span>)}</span> at location <span class="hljs-subst">{box}</span>&quot;</span>
<span class="hljs-meta">... </span>    )
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.998</span> at location [<span class="hljs-number">40.16</span>, <span class="hljs-number">70.81</span>, <span class="hljs-number">175.55</span>, <span class="hljs-number">117.98</span>]
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.996</span> at location [<span class="hljs-number">333.24</span>, <span class="hljs-number">72.55</span>, <span class="hljs-number">368.33</span>, <span class="hljs-number">187.66</span>]
Detected couch <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.995</span> at location [-<span class="hljs-number">0.02</span>, <span class="hljs-number">1.15</span>, <span class="hljs-number">639.73</span>, <span class="hljs-number">473.76</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">13.24</span>, <span class="hljs-number">52.05</span>, <span class="hljs-number">314.02</span>, <span class="hljs-number">470.93</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">345.4</span>, <span class="hljs-number">23.85</span>, <span class="hljs-number">640.37</span>, <span class="hljs-number">368.72</span>]`}}),{c(){f=a("p"),E=n("Examples:"),g=d(),b(u.$$.fragment)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Examples:"),_.forEach(t),g=c(m),v(u.$$.fragment,m)},m(m,_){p(m,f,_),e(f,E),p(m,g,_),D(u,m,_),T=!0},p:li,i(m){T||(y(u.$$.fragment,m),T=!0)},o(m){w(u.$$.fragment,m),T=!1},d(m){m&&t(f),m&&t(g),x(u,m)}}}function w_(z){let f,E,g,u,T;return{c(){f=a("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),g=a("code"),u=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),g=s(_,"CODE",{});var U=i(g);u=r(U,"Module"),U.forEach(t),T=r(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(t)},m(m,_){p(m,f,_),e(f,E),e(f,g),e(g,u),e(f,T)},d(m){m&&t(f)}}}function x_(z){let f,E,g,u,T;return u=new So({props:{code:`import io
import requests
from PIL import Image
import torch
import numpy

from transformers import DetrFeatureExtractor, DetrForSegmentation
from transformers.models.detr.feature_extraction_detr import rgb_to_id

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

feature_extractor = DetrFeatureExtractor.from_pretrained("facebook/detr-resnet-50-panoptic")
model = DetrForSegmentation.from_pretrained("facebook/detr-resnet-50-panoptic")

# prepare image for the model
inputs = feature_extractor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# Use the \`post_process_panoptic_segmentation\` method of \`DetrFeatureExtractor\` to retrieve post-processed panoptic segmentation maps
# Segmentation results are returned as a list of dictionaries
result = feature_extractor.post_process_panoptic_segmentation(outputs, target_sizes=[(300, 500)])

# A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found
panoptic_seg = result[0]["segmentation"]
# Get prediction score and segment_id to class_id mapping of each segment
panoptic_segments_info = result[0]["segments_info"]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> io
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrFeatureExtractor, DetrForSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.models.detr.feature_extraction_detr <span class="hljs-keyword">import</span> rgb_to_id

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = DetrFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForSegmentation.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use the \`post_process_panoptic_segmentation\` method of \`DetrFeatureExtractor\` to retrieve post-processed panoptic segmentation maps</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Segmentation results are returned as a list of dictionaries</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>result = feature_extractor.post_process_panoptic_segmentation(outputs, target_sizes=[(<span class="hljs-number">300</span>, <span class="hljs-number">500</span>)])

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_seg = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segmentation&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Get prediction score and segment_id to class_id mapping of each segment</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_segments_info = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segments_info&quot;</span>]`}}),{c(){f=a("p"),E=n("Examples:"),g=d(),b(u.$$.fragment)},l(m){f=s(m,"P",{});var _=i(f);E=r(_,"Examples:"),_.forEach(t),g=c(m),v(u.$$.fragment,m)},m(m,_){p(m,f,_),e(f,E),p(m,g,_),D(u,m,_),T=!0},p:li,i(m){T||(y(u.$$.fragment,m),T=!0)},o(m){w(u.$$.fragment,m),T=!1},d(m){m&&t(f),m&&t(g),x(u,m)}}}function T_(z){let f,E,g,u,T,m,_,U,hi,Ua,De,Me,An,jt,mi,Mn,pi,Wa,Ie,fi,$t,ui,gi,Ga,Ao,_i,Ba,Mo,In,bi,Va,fe,vi,Ot,Di,yi,zt,wi,xi,Ya,Le,Ti,Ct,Ei,Fi,Qa,Re,ki,Io,ji,$i,Ka,j,Oi,Ln,zi,Ci,Rn,qi,Pi,Hn,Ni,Si,Un,Ai,Mi,Wn,Ii,Li,Gn,Ri,Hi,Bn,Ui,Wi,Vn,Gi,Bi,Za,C,Vi,Yn,Yi,Qi,Qn,Ki,Zi,Kn,Ji,Xi,Zn,ed,td,Jn,od,nd,Xn,rd,ad,Ja,Y,sd,er,id,dd,qt,cd,ld,Pt,hd,md,Xa,Q,pd,Lo,fd,ud,Ro,gd,_d,Ho,bd,vd,es,Uo,Dd,ts,$,te,yd,tr,wd,xd,or,Td,Ed,Wo,Fd,kd,jd,nr,$d,Od,oe,zd,rr,Cd,qd,Go,Pd,Nd,ar,Sd,Ad,Md,ne,Id,sr,Ld,Rd,Bo,Hd,Ud,ir,Wd,Gd,Bd,G,Vd,dr,Yd,Qd,cr,Kd,Zd,lr,Jd,Xd,Nt,ec,tc,oc,S,Vo,nc,rc,Yo,ac,sc,St,ic,dc,hr,cc,lc,Qo,hc,mc,mr,pc,fc,uc,re,gc,Ko,_c,bc,pr,vc,Dc,Zo,yc,wc,xc,ye,Tc,fr,Ec,Fc,At,kc,jc,os,Jo,$c,ns,Xo,Oc,rs,Mt,as,en,zc,ss,It,is,tn,Cc,ds,Lt,cs,on,qc,ls,He,ur,ae,gr,Pc,Nc,_r,Sc,Ac,br,Mc,Ic,vr,Lc,Rc,M,se,Dr,yr,Hc,Uc,wr,Wc,Gc,xr,Bc,Vc,Tr,Yc,Qc,ie,Er,Fr,Kc,Zc,kr,nn,Jc,Xc,jr,rn,el,tl,$r,an,ol,nl,de,Or,zr,rl,al,Cr,sl,il,qr,dl,cl,Pr,ll,hl,ce,Rt,Nr,ml,pl,sn,fl,ul,we,gl,Sr,_l,bl,Ar,vl,Dl,yl,I,wl,Mr,xl,Tl,Ir,El,Fl,Lr,kl,jl,Rr,$l,Ol,Hr,zl,Cl,ql,le,Pl,Ur,Nl,Sl,Wr,Al,Ml,Gr,Il,Ll,Rl,he,dn,Br,Hl,Ul,Wl,Vr,Yr,Gl,Bl,Qr,Kr,Vl,Yl,Ht,Zr,Ql,Kl,Jr,Zl,Jl,me,Xr,ea,Xl,eh,Ut,ta,th,oh,oa,nh,rh,xe,na,ah,sh,ra,ih,dh,aa,ch,lh,pe,sa,hh,mh,ia,ph,fh,da,uh,gh,ca,_h,hs,F,bh,cn,vh,Dh,la,yh,wh,ha,xh,Th,ma,Eh,Fh,ln,kh,jh,pa,$h,Oh,fa,zh,Ch,Wt,qh,Ph,Gt,Nh,Sh,ms,Te,Ue,ua,Bt,Ah,ga,Mh,ps,Ee,Vt,Ih,_a,Lh,fs,Fe,Yt,Rh,Qt,Hh,hn,Uh,Wh,us,ke,Kt,Gh,Zt,Bh,mn,Vh,Yh,gs,je,We,ba,Jt,Qh,va,Kh,_s,B,Xt,Zh,$e,Jh,pn,Xh,em,eo,tm,om,nm,Oe,rm,fn,am,sm,un,im,dm,cm,Ge,bs,ze,Be,Da,to,lm,ya,hm,vs,k,oo,mm,wa,pm,fm,no,um,gn,gm,_m,bm,ue,ro,vm,xa,Dm,ym,Ve,wm,Ye,ao,xm,so,Tm,Ta,Em,Fm,km,Qe,io,jm,co,$m,_n,Om,zm,Cm,Ke,lo,qm,ho,Pm,bn,Nm,Sm,Am,Ze,mo,Mm,po,Im,vn,Lm,Rm,Hm,Je,fo,Um,uo,Wm,Dn,Gm,Bm,Ds,Ce,Xe,Ea,go,Vm,Fa,Ym,ys,L,_o,Qm,ka,Km,Zm,bo,Jm,yn,Xm,ep,tp,vo,op,Do,np,rp,ap,K,yo,sp,qe,ip,wn,dp,cp,ja,lp,hp,mp,et,pp,tt,ws,Pe,ot,$a,wo,fp,Oa,up,xs,R,xo,gp,za,_p,bp,To,vp,xn,Dp,yp,wp,Eo,xp,Fo,Tp,Ep,Fp,Z,ko,kp,Ne,jp,Tn,$p,Op,Ca,zp,Cp,qp,nt,Pp,rt,Ts,Se,at,qa,jo,Np,Pa,Sp,Es,H,$o,Ap,Na,Mp,Ip,Oo,Lp,En,Rp,Hp,Up,zo,Wp,Co,Gp,Bp,Vp,J,qo,Yp,Ae,Qp,Fn,Kp,Zp,Sa,Jp,Xp,ef,st,tf,it,Fs;return m=new kt({}),jt=new kt({}),Mt=new So({props:{code:`from transformers import DetrForObjectDetection

model = DetrForObjectDetection.from_pretrained("facebook/resnet-50")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/resnet-50&quot;</span>)`}}),It=new So({props:{code:`from transformers import DetrConfig, DetrForObjectDetection

config = DetrConfig()
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),Lt=new So({props:{code:`config = DetrConfig(use_pretrained_backbone=False)
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig(use_pretrained_backbone=<span class="hljs-literal">False</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),Bt=new kt({}),Vt=new N({props:{name:"class transformers.models.detr.modeling_detr.DetrModelOutput",anchor:"transformers.models.detr.modeling_detr.DetrModelOutput",parameters:[{name:"last_hidden_state",val:": FloatTensor = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"intermediate_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.intermediate_hidden_states",description:`<strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) &#x2014;
Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.`,name:"intermediate_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L95"}}),Yt=new N({props:{name:"class transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L135"}}),Kt=new N({props:{name:"class transformers.models.detr.modeling_detr.DetrSegmentationOutput",anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"pred_masks",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_masks",description:`<strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) &#x2014;
Segmentation masks logits for all queries. See also
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation">post_process_semantic_segmentation()</a> or
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation">post_process_instance_segmentation()</a>
<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation">post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.`,name:"pred_masks"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L198"}}),Jt=new kt({}),Xt=new N({props:{name:"class transformers.DetrConfig",anchor:"transformers.DetrConfig",parameters:[{name:"num_channels",val:" = 3"},{name:"num_queries",val:" = 100"},{name:"max_position_embeddings",val:" = 1024"},{name:"encoder_layers",val:" = 6"},{name:"encoder_ffn_dim",val:" = 2048"},{name:"encoder_attention_heads",val:" = 8"},{name:"decoder_layers",val:" = 6"},{name:"decoder_ffn_dim",val:" = 2048"},{name:"decoder_attention_heads",val:" = 8"},{name:"encoder_layerdrop",val:" = 0.0"},{name:"decoder_layerdrop",val:" = 0.0"},{name:"is_encoder_decoder",val:" = True"},{name:"activation_function",val:" = 'relu'"},{name:"d_model",val:" = 256"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.0"},{name:"activation_dropout",val:" = 0.0"},{name:"init_std",val:" = 0.02"},{name:"init_xavier_std",val:" = 1.0"},{name:"classifier_dropout",val:" = 0.0"},{name:"scale_embedding",val:" = False"},{name:"auxiliary_loss",val:" = False"},{name:"position_embedding_type",val:" = 'sine'"},{name:"backbone",val:" = 'resnet50'"},{name:"use_pretrained_backbone",val:" = True"},{name:"dilation",val:" = False"},{name:"class_cost",val:" = 1"},{name:"bbox_cost",val:" = 5"},{name:"giou_cost",val:" = 2"},{name:"mask_loss_coefficient",val:" = 1"},{name:"dice_loss_coefficient",val:" = 1"},{name:"bbox_loss_coefficient",val:" = 5"},{name:"giou_loss_coefficient",val:" = 2"},{name:"eos_coefficient",val:" = 0.1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.DetrConfig.num_queries",description:`<strong>num_queries</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Number of object queries, i.e. detection slots. This is the maximal number of objects <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrModel">DetrModel</a> can
detect in a single image. For COCO, we recommend 100 queries.`,name:"num_queries"},{anchor:"transformers.DetrConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimension of the layers.`,name:"d_model"},{anchor:"transformers.DetrConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of encoder layers.`,name:"encoder_layers"},{anchor:"transformers.DetrConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.DetrConfig.encoder_attention_heads",description:`<strong>encoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"encoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.DetrConfig.encoder_ffn_dim",description:`<strong>encoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"encoder_ffn_dim"},{anchor:"transformers.DetrConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.DetrConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.DetrConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.DetrConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.DetrConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.DetrConfig.init_xavier_std",description:`<strong>init_xavier_std</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The scaling factor used for the Xavier initialization gain in the HM Attention map module.`,name:"init_xavier_std"},{anchor:"transformers.DetrConfig.encoder_layerdrop",description:`<strong>encoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the encoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"encoder_layerdrop"},{anchor:"transformers.DetrConfig.decoder_layerdrop",description:`<strong>decoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the decoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"decoder_layerdrop"},{anchor:"transformers.DetrConfig.auxiliary_loss",description:`<strong>auxiliary_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether auxiliary decoding losses (loss at each decoder layer) are to be used.`,name:"auxiliary_loss"},{anchor:"transformers.DetrConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sine&quot;</code>) &#x2014;
Type of position embeddings to be used on top of the image features. One of <code>&quot;sine&quot;</code> or <code>&quot;learned&quot;</code>.`,name:"position_embedding_type"},{anchor:"transformers.DetrConfig.backbone",description:`<strong>backbone</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;resnet50&quot;</code>) &#x2014;
Name of convolutional backbone to use. Supports any convolutional backbone from the timm package. For a
list of all available models, see <a href="https://rwightman.github.io/pytorch-image-models/#load-a-pretrained-model" rel="nofollow">this
page</a>.`,name:"backbone"},{anchor:"transformers.DetrConfig.use_pretrained_backbone",description:`<strong>use_pretrained_backbone</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use pretrained weights for the backbone.`,name:"use_pretrained_backbone"},{anchor:"transformers.DetrConfig.dilation",description:`<strong>dilation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to replace stride with dilation in the last convolutional block (DC5).`,name:"dilation"},{anchor:"transformers.DetrConfig.class_cost",description:`<strong>class_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the classification error in the Hungarian matching cost.`,name:"class_cost"},{anchor:"transformers.DetrConfig.bbox_cost",description:`<strong>bbox_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 error of the bounding box coordinates in the Hungarian matching cost.`,name:"bbox_cost"},{anchor:"transformers.DetrConfig.giou_cost",description:`<strong>giou_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss of the bounding box in the Hungarian matching cost.`,name:"giou_cost"},{anchor:"transformers.DetrConfig.mask_loss_coefficient",description:`<strong>mask_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the Focal loss in the panoptic segmentation loss.`,name:"mask_loss_coefficient"},{anchor:"transformers.DetrConfig.dice_loss_coefficient",description:`<strong>dice_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the DICE/F-1 loss in the panoptic segmentation loss.`,name:"dice_loss_coefficient"},{anchor:"transformers.DetrConfig.bbox_loss_coefficient",description:`<strong>bbox_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 bounding box loss in the object detection loss.`,name:"bbox_loss_coefficient"},{anchor:"transformers.DetrConfig.giou_loss_coefficient",description:`<strong>giou_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss in the object detection loss.`,name:"giou_loss_coefficient"},{anchor:"transformers.DetrConfig.eos_coefficient",description:`<strong>eos_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Relative classification weight of the &#x2018;no-object&#x2019; class in the object detection loss.`,name:"eos_coefficient"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/configuration_detr.py#L35"}}),Ge=new ci({props:{anchor:"transformers.DetrConfig.example",$$slots:{default:[g_]},$$scope:{ctx:z}}}),to=new kt({}),oo=new N({props:{name:"class transformers.DetrFeatureExtractor",anchor:"transformers.DetrFeatureExtractor",parameters:[{name:"format",val:" = 'coco_detection'"},{name:"do_resize",val:" = True"},{name:"size",val:" = 800"},{name:"max_size",val:" = 1333"},{name:"do_normalize",val:" = True"},{name:"image_mean",val:" = None"},{name:"image_std",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.format",description:`<strong>format</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;coco_detection&quot;</code>) &#x2014;
Data format of the annotations. One of &#x201C;coco_detection&#x201D; or &#x201C;coco_panoptic&#x201D;.`,name:"format"},{anchor:"transformers.DetrFeatureExtractor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to resize the input to a certain <code>size</code>.`,name:"do_resize"},{anchor:"transformers.DetrFeatureExtractor.size",description:`<strong>size</strong> (<code>int</code>, <em>optional</em>, defaults to 800) &#x2014;
Resize the input to the given size. Only has an effect if <code>do_resize</code> is set to <code>True</code>. If size is a
sequence like <code>(width, height)</code>, output size will be matched to this. If size is an int, smaller edge of
the image will be matched to this number. i.e, if <code>height &gt; width</code>, then image will be rescaled to <code>(size * height / width, size)</code>.`,name:"size"},{anchor:"transformers.DetrFeatureExtractor.max_size",description:`<strong>max_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1333) &#x2014;
The largest size an image dimension can have (otherwise it&#x2019;s capped). Only has an effect if <code>do_resize</code> is
set to <code>True</code>.`,name:"max_size"},{anchor:"transformers.DetrFeatureExtractor.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to normalize the input with mean and standard deviation.`,name:"do_normalize"},{anchor:"transformers.DetrFeatureExtractor.image_mean",description:`<strong>image_mean</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.485, 0.456, 0.406]</code>) &#x2014;
The sequence of means for each channel, to be used when normalizing images. Defaults to the ImageNet mean.`,name:"image_mean"},{anchor:"transformers.DetrFeatureExtractor.image_std",description:`<strong>image_std</strong> (<code>int</code>, <em>optional</em>, defaults to <code>[0.229, 0.224, 0.225]</code>) &#x2014;
The sequence of standard deviations for each channel, to be used when normalizing images. Defaults to the
ImageNet std.`,name:"image_std"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L223"}}),ro=new N({props:{name:"__call__",anchor:"transformers.DetrFeatureExtractor.__call__",parameters:[{name:"images",val:": typing.Union[PIL.Image.Image, numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[PIL.Image.Image], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"annotations",val:": typing.Union[typing.List[typing.Dict], typing.List[typing.List[typing.Dict]]] = None"},{name:"return_segmentation_masks",val:": typing.Optional[bool] = False"},{name:"masks_path",val:": typing.Optional[pathlib.Path] = None"},{name:"pad_and_return_pixel_mask",val:": typing.Optional[bool] = True"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.__call__.images",description:`<strong>images</strong> (<code>PIL.Image.Image</code>, <code>np.ndarray</code>, <code>torch.Tensor</code>, <code>List[PIL.Image.Image]</code>, <code>List[np.ndarray]</code>, <code>List[torch.Tensor]</code>) &#x2014;
The image or batch of images to be prepared. Each image can be a PIL image, NumPy array or PyTorch
tensor. In case of a NumPy array/PyTorch tensor, each image should be of shape (C, H, W), where C is a
number of channels, H and W are image height and width.`,name:"images"},{anchor:"transformers.DetrFeatureExtractor.__call__.annotations",description:`<strong>annotations</strong> (<code>Dict</code>, <code>List[Dict]</code>, <em>optional</em>) &#x2014;
The corresponding annotations in COCO format.</p>
<p>In case <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a> was initialized with <code>format = &quot;coco_detection&quot;</code>, the annotations for
each image should have the following format: {&#x2018;image_id&#x2019;: int, &#x2018;annotations&#x2019;: [annotation]}, with the
annotations being a list of COCO object annotations.</p>
<p>In case <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a> was initialized with <code>format = &quot;coco_panoptic&quot;</code>, the annotations for
each image should have the following format: {&#x2018;image_id&#x2019;: int, &#x2018;file_name&#x2019;: str, &#x2018;segments_info&#x2019;:
[segment_info]} with segments_info being a list of COCO panoptic annotations.`,name:"annotations"},{anchor:"transformers.DetrFeatureExtractor.__call__.return_segmentation_masks",description:`<strong>return_segmentation_masks</strong> (<code>Dict</code>, <code>List[Dict]</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to also include instance segmentation masks as part of the labels in case <code>format = &quot;coco_detection&quot;</code>.`,name:"return_segmentation_masks"},{anchor:"transformers.DetrFeatureExtractor.__call__.masks_path",description:`<strong>masks_path</strong> (<code>pathlib.Path</code>, <em>optional</em>) &#x2014;
Path to the directory containing the PNG files that store the class-agnostic image segmentations. Only
relevant in case <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a> was initialized with <code>format = &quot;coco_panoptic&quot;</code>.`,name:"masks_path"},{anchor:"transformers.DetrFeatureExtractor.__call__.pad_and_return_pixel_mask",description:`<strong>pad_and_return_pixel_mask</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to pad images up to the largest image in a batch and create a pixel mask.</p>
<p>If left to the default, will return a pixel mask that is:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>`,name:"pad_and_return_pixel_mask"},{anchor:"transformers.DetrFeatureExtractor.__call__.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/main/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of NumPy arrays. If set to <code>&apos;pt&apos;</code>, return PyTorch <code>torch.Tensor</code>
objects.`,name:"return_tensors"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L504",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/feature_extractor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li><strong>pixel_values</strong> \u2014 Pixel values to be fed to a model.</li>
<li><strong>pixel_mask</strong> \u2014 Pixel mask to be fed to a model (when <code>pad_and_return_pixel_mask=True</code> or if
<em>\u201Cpixel_mask\u201D</em> is in <code>self.model_input_names</code>).</li>
<li><strong>labels</strong> \u2014 Optional labels to be fed to a model (when <code>annotations</code> are provided)</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/feature_extractor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),Ve=new di({props:{warning:!0,$$slots:{default:[__]},$$scope:{ctx:z}}}),ao=new N({props:{name:"pad_and_create_pixel_mask",anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask",parameters:[{name:"pixel_values_list",val:": typing.List[ForwardRef('torch.Tensor')]"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.pixel_values_list",description:`<strong>pixel_values_list</strong> (<code>List[torch.Tensor]</code>) &#x2014;
List of images (pixel values) to be padded. Each image should be a tensor of shape (C, H, W).`,name:"pixel_values_list"},{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/main/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of NumPy arrays. If set to <code>&apos;pt&apos;</code>, return PyTorch <code>torch.Tensor</code>
objects.`,name:"return_tensors"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L742",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/feature_extractor#transformers.BatchFeature"
>BatchFeature</a> with the following fields:</p>
<ul>
<li><strong>pixel_values</strong> \u2014 Pixel values to be fed to a model.</li>
<li><strong>pixel_mask</strong> \u2014 Pixel mask to be fed to a model (when <code>pad_and_return_pixel_mask=True</code> or if
<em>\u201Cpixel_mask\u201D</em> is in <code>self.model_input_names</code>).</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/feature_extractor#transformers.BatchFeature"
>BatchFeature</a></p>
`}}),io=new N({props:{name:"post_process_object_detection",anchor:"transformers.DetrFeatureExtractor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
(height, width) of each image in the batch. If left to None, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L1064",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),lo=new N({props:{name:"post_process_semantic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple[int, int]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
A list of tuples (<code>Tuple[int, int]</code>) containing the target size (height, width) of each image in the
batch. If left to None, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L1118",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),mo=new N({props:{name:"post_process_instance_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If left to None, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Defaults to <code>False</code>. If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE)
format.`,name:"return_coco_annotation"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L1166",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),fo=new N({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
The outputs from <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If left to None, predictions will not be
resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/feature_extraction_detr.py#L1250",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized to
the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),go=new kt({}),_o=new N({props:{name:"class transformers.DetrModel",anchor:"transformers.DetrModel",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1190"}}),yo=new N({props:{name:"forward",anchor:"transformers.DetrModel.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a>. See <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.__call__">DetrFeatureExtractor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.DetrModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrModel.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrModel.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrModel.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1226",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) \u2014 Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),et=new di({props:{$$slots:{default:[b_]},$$scope:{ctx:z}}}),tt=new ci({props:{anchor:"transformers.DetrModel.forward.example",$$slots:{default:[v_]},$$scope:{ctx:z}}}),wo=new kt({}),xo=new N({props:{name:"class transformers.DetrForObjectDetection",anchor:"transformers.DetrForObjectDetection",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1360"}}),ko=new N({props:{name:"forward",anchor:"transformers.DetrForObjectDetection.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a>. See <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.__call__">DetrFeatureExtractor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.DetrForObjectDetection.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForObjectDetection.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForObjectDetection.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForObjectDetection.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForObjectDetection.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForObjectDetection.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss. List of dicts, each dictionary containing at least the
following 2 keys: &#x2018;class_labels&#x2019; and &#x2018;boxes&#x2019; (the class labels and bounding boxes of an image in the batch
respectively). The class labels themselves should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code> and the boxes a <code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1386",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),nt=new di({props:{$$slots:{default:[D_]},$$scope:{ctx:z}}}),rt=new ci({props:{anchor:"transformers.DetrForObjectDetection.forward.example",$$slots:{default:[y_]},$$scope:{ctx:z}}}),jo=new kt({}),$o=new N({props:{name:"class transformers.DetrForSegmentation",anchor:"transformers.DetrForSegmentation",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1534"}}),qo=new N({props:{name:"forward",anchor:"transformers.DetrForSegmentation.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor">DetrFeatureExtractor</a>. See <a href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.__call__">DetrFeatureExtractor.<strong>call</strong>()</a> for
details.`,name:"pixel_values"},{anchor:"transformers.DetrForSegmentation.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForSegmentation.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForSegmentation.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForSegmentation.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForSegmentation.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss, DICE/F-1 loss and Focal loss. List of dicts, each
dictionary containing at least the following 3 keys: &#x2018;class_labels&#x2019;, &#x2018;boxes&#x2019; and &#x2018;masks&#x2019; (the class labels,
bounding boxes and segmentation masks of an image in the batch respectively). The class labels themselves
should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code>, the boxes a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code> and the masks a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, height, width)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/detr/modeling_detr.py#L1556",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) \u2014 Segmentation masks logits for all queries. See also
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation"
>post_process_semantic_segmentation()</a> or
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation"
>post_process_instance_segmentation()</a>
<a
  href="/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation"
>post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),st=new di({props:{$$slots:{default:[w_]},$$scope:{ctx:z}}}),it=new ci({props:{anchor:"transformers.DetrForSegmentation.forward.example",$$slots:{default:[x_]},$$scope:{ctx:z}}}),{c(){f=a("meta"),E=d(),g=a("h1"),u=a("a"),T=a("span"),b(m.$$.fragment),_=d(),U=a("span"),hi=n("DETR"),Ua=d(),De=a("h2"),Me=a("a"),An=a("span"),b(jt.$$.fragment),mi=d(),Mn=a("span"),pi=n("Overview"),Wa=d(),Ie=a("p"),fi=n("The DETR model was proposed in "),$t=a("a"),ui=n("End-to-End Object Detection with Transformers"),gi=n(` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),Ga=d(),Ao=a("p"),_i=n("The abstract from the paper is the following:"),Ba=d(),Mo=a("p"),In=a("em"),bi=n(`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),Va=d(),fe=a("p"),vi=n("This model was contributed by "),Ot=a("a"),Di=n("nielsr"),yi=n(". The original code can be found "),zt=a("a"),wi=n("here"),xi=n("."),Ya=d(),Le=a("p"),Ti=n("The quickest way to get started with DETR is by checking the "),Ct=a("a"),Ei=n("example notebooks"),Fi=n(` (which showcase both inference and
fine-tuning on custom data).`),Qa=d(),Re=a("p"),ki=n("Here\u2019s a TLDR explaining how "),Io=a("a"),ji=n("DetrForObjectDetection"),$i=n(" works:"),Ka=d(),j=a("p"),Oi=n(`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),Ln=a("code"),zi=n("(batch_size, 3, height, width)"),Ci=n(`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),Rn=a("code"),qi=n("(batch_size, 2048, height/32, width/32)"),Pi=n(`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),Hn=a("code"),Ni=n("256"),Si=n(` by default, using a
`),Un=a("code"),Ai=n("nn.Conv2D"),Mi=n(" layer. So now, we have a tensor of shape "),Wn=a("code"),Ii=n("(batch_size, 256, height/32, width/32)."),Li=n(` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),Gn=a("code"),Ri=n("(batch_size, seq_len, d_model)"),Hi=n(` =
`),Bn=a("code"),Ui=n("(batch_size, width/32*height/32, 256)"),Wi=n(`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),Vn=a("code"),Gi=n("d_model"),Bi=n(" (which in NLP is typically 768 or higher)."),Za=d(),C=a("p"),Vi=n("Next, this is sent through the encoder, outputting "),Yn=a("code"),Yi=n("encoder_hidden_states"),Qi=n(` of the same shape (you can consider
these as image features). Next, so-called `),Qn=a("strong"),Ki=n("object queries"),Zi=n(` are sent through the decoder. This is a tensor of shape
`),Kn=a("code"),Ji=n("(batch_size, num_queries, d_model)"),Xi=n(", with "),Zn=a("code"),ed=n("num_queries"),td=n(` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),Jn=a("code"),od=n("decoder_hidden_states"),nd=n(" of the same shape: "),Xn=a("code"),rd=n("(batch_size, num_queries, d_model)"),ad=n(`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),Ja=d(),Y=a("p"),sd=n("The model is trained using a "),er=a("strong"),id=n("bipartite matching loss"),dd=n(`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),qt=a("a"),cd=n("Hungarian matching algorithm"),ld=n(` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Pt=a("a"),hd=n("generalized IoU loss"),md=n(` (for the
bounding boxes) are used to optimize the parameters of the model.`),Xa=d(),Q=a("p"),pd=n(`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),Lo=a("a"),fd=n("DetrForSegmentation"),ud=n(` adds a segmentation mask head on top of
`),Ro=a("a"),gd=n("DetrForObjectDetection"),_d=n(`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),Ho=a("a"),bd=n("DetrForObjectDetection"),vd=n(` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),es=d(),Uo=a("p"),Dd=n("Tips:"),ts=d(),$=a("ul"),te=a("li"),yd=n("DETR uses so-called "),tr=a("strong"),wd=n("object queries"),xd=n(` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),or=a("code"),Td=n("num_queries"),Ed=n(" of "),Wo=a("a"),Fd=n("DetrConfig"),kd=n(`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),jd=d(),nr=a("li"),$d=n(`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),Od=d(),oe=a("li"),zd=n(`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),rr=a("code"),Cd=n("position_embedding_type"),qd=n(` of
`),Go=a("a"),Pd=n("DetrConfig"),Nd=n(" is set to "),ar=a("code"),Sd=n('"sine"'),Ad=n("."),Md=d(),ne=a("li"),Id=n(`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),sr=a("code"),Ld=n("auxiliary_loss"),Rd=n(` of
`),Bo=a("a"),Hd=n("DetrConfig"),Ud=n(" to "),ir=a("code"),Wd=n("True"),Gd=n(`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),Bd=d(),G=a("li"),Vd=n(`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),dr=a("em"),Yd=n("num_boxes"),Qd=n(" variable in the "),cr=a("em"),Kd=n("DetrLoss"),Zd=n(" class of "),lr=a("em"),Jd=n("modeling_detr.py"),Xd=n(`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Nt=a("a"),ec=n("here"),tc=n("."),oc=d(),S=a("li"),Vo=a("a"),nc=n("DetrForObjectDetection"),rc=n(" and "),Yo=a("a"),ac=n("DetrForSegmentation"),sc=n(` can be initialized with
any convolutional backbone available in the `),St=a("a"),ic=n("timm library"),dc=n(`.
Initializing with a MobileNet backbone for example can be done by setting the `),hr=a("code"),cc=n("backbone"),lc=n(` attribute of
`),Qo=a("a"),hc=n("DetrConfig"),mc=n(" to "),mr=a("code"),pc=n('"tf_mobilenetv3_small_075"'),fc=n(`, and then initializing the model with that
config.`),uc=d(),re=a("li"),gc=n(`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),Ko=a("a"),_c=n("DetrFeatureExtractor"),bc=n(` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),pr=a("code"),vc=n("collate_fn"),Dc=n(` in order to batch images together, using
`),Zo=a("a"),yc=n("pad_and_create_pixel_mask()"),wc=n("."),xc=d(),ye=a("li"),Tc=n("The size of the images will determine the amount of memory being used, and will thus determine the "),fr=a("code"),Ec=n("batch_size"),Fc=n(`.
It is advised to use a batch size of 2 per GPU. See `),At=a("a"),kc=n("this Github thread"),jc=n(" for more info."),os=d(),Jo=a("p"),$c=n("There are three ways to instantiate a DETR model (depending on what you prefer):"),ns=d(),Xo=a("p"),Oc=n("Option 1: Instantiate DETR with pre-trained weights for entire model"),rs=d(),b(Mt.$$.fragment),as=d(),en=a("p"),zc=n("Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),ss=d(),b(It.$$.fragment),is=d(),tn=a("p"),Cc=n("Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),ds=d(),b(Lt.$$.fragment),cs=d(),on=a("p"),qc=n("As a summary, consider the following table:"),ls=d(),He=a("table"),ur=a("thead"),ae=a("tr"),gr=a("th"),Pc=n("Task"),Nc=d(),_r=a("th"),Sc=n("Object detection"),Ac=d(),br=a("th"),Mc=n("Instance segmentation"),Ic=d(),vr=a("th"),Lc=n("Panoptic segmentation"),Rc=d(),M=a("tbody"),se=a("tr"),Dr=a("td"),yr=a("strong"),Hc=n("Description"),Uc=d(),wr=a("td"),Wc=n("Predicting bounding boxes and class labels around objects in an image"),Gc=d(),xr=a("td"),Bc=n("Predicting masks around objects (i.e. instances) in an image"),Vc=d(),Tr=a("td"),Yc=n("Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),Qc=d(),ie=a("tr"),Er=a("td"),Fr=a("strong"),Kc=n("Model"),Zc=d(),kr=a("td"),nn=a("a"),Jc=n("DetrForObjectDetection"),Xc=d(),jr=a("td"),rn=a("a"),el=n("DetrForSegmentation"),tl=d(),$r=a("td"),an=a("a"),ol=n("DetrForSegmentation"),nl=d(),de=a("tr"),Or=a("td"),zr=a("strong"),rl=n("Example dataset"),al=d(),Cr=a("td"),sl=n("COCO detection"),il=d(),qr=a("td"),dl=n("COCO detection, COCO panoptic"),cl=d(),Pr=a("td"),ll=n("COCO panoptic"),hl=d(),ce=a("tr"),Rt=a("td"),Nr=a("strong"),ml=n("Format of annotations to provide to"),pl=d(),sn=a("a"),fl=n("DetrFeatureExtractor"),ul=d(),we=a("td"),gl=n("{\u2018image_id\u2019: "),Sr=a("code"),_l=n("int"),bl=n(", \u2018annotations\u2019: "),Ar=a("code"),vl=n("List[Dict]"),Dl=n("} each Dict being a COCO object annotation"),yl=d(),I=a("td"),wl=n("{\u2018image_id\u2019: "),Mr=a("code"),xl=n("int"),Tl=n(", \u2018annotations\u2019: "),Ir=a("code"),El=n("List[Dict]"),Fl=n("}  (in case of COCO detection) or {\u2018file_name\u2019: "),Lr=a("code"),kl=n("str"),jl=n(", \u2018image_id\u2019: "),Rr=a("code"),$l=n("int"),Ol=n(", \u2018segments_info\u2019: "),Hr=a("code"),zl=n("List[Dict]"),Cl=n("} (in case of COCO panoptic)"),ql=d(),le=a("td"),Pl=n("{\u2018file_name\u2019: "),Ur=a("code"),Nl=n("str"),Sl=n(", \u2018image_id\u2019: "),Wr=a("code"),Al=n("int"),Ml=n(", \u2018segments_info\u2019: "),Gr=a("code"),Il=n("List[Dict]"),Ll=n("} and masks_path (path to directory containing PNG files of the masks)"),Rl=d(),he=a("tr"),dn=a("td"),Br=a("strong"),Hl=n("Postprocessing"),Ul=n(" (i.e. converting the output of the model to COCO API)"),Wl=d(),Vr=a("td"),Yr=a("code"),Gl=n("post_process()"),Bl=d(),Qr=a("td"),Kr=a("code"),Vl=n("post_process_segmentation()"),Yl=d(),Ht=a("td"),Zr=a("code"),Ql=n("post_process_segmentation()"),Kl=n(", "),Jr=a("code"),Zl=n("post_process_panoptic()"),Jl=d(),me=a("tr"),Xr=a("td"),ea=a("strong"),Xl=n("evaluators"),eh=d(),Ut=a("td"),ta=a("code"),th=n("CocoEvaluator"),oh=n(" with "),oa=a("code"),nh=n('iou_types="bbox"'),rh=d(),xe=a("td"),na=a("code"),ah=n("CocoEvaluator"),sh=n(" with "),ra=a("code"),ih=n('iou_types="bbox"'),dh=n(" or "),aa=a("code"),ch=n('"segm"'),lh=d(),pe=a("td"),sa=a("code"),hh=n("CocoEvaluator"),mh=n(" with "),ia=a("code"),ph=n('iou_tupes="bbox"'),fh=n(" or "),da=a("code"),uh=n('"segm"'),gh=n(", "),ca=a("code"),_h=n("PanopticEvaluator"),hs=d(),F=a("p"),bh=n(`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),cn=a("a"),vh=n("DetrFeatureExtractor"),Dh=n(" to create "),la=a("code"),yh=n("pixel_values"),wh=n(", "),ha=a("code"),xh=n("pixel_mask"),Th=n(` and optional
`),ma=a("code"),Eh=n("labels"),Fh=n(`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),ln=a("a"),kh=n("DetrFeatureExtractor"),jh=n(`. These can
be be provided to either `),pa=a("code"),$h=n("CocoEvaluator"),Oh=n(" or "),fa=a("code"),zh=n("PanopticEvaluator"),Ch=n(`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),Wt=a("a"),qh=n("original repository"),Ph=n(". See the "),Gt=a("a"),Nh=n("example notebooks"),Sh=n(" for more info regarding evaluation."),ms=d(),Te=a("h2"),Ue=a("a"),ua=a("span"),b(Bt.$$.fragment),Ah=d(),ga=a("span"),Mh=n("DETR specific outputs"),ps=d(),Ee=a("div"),b(Vt.$$.fragment),Ih=d(),_a=a("p"),Lh=n(`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),fs=d(),Fe=a("div"),b(Yt.$$.fragment),Rh=d(),Qt=a("p"),Hh=n("Output type of "),hn=a("a"),Uh=n("DetrForObjectDetection"),Wh=n("."),us=d(),ke=a("div"),b(Kt.$$.fragment),Gh=d(),Zt=a("p"),Bh=n("Output type of "),mn=a("a"),Vh=n("DetrForSegmentation"),Yh=n("."),gs=d(),je=a("h2"),We=a("a"),ba=a("span"),b(Jt.$$.fragment),Qh=d(),va=a("span"),Kh=n("DetrConfig"),_s=d(),B=a("div"),b(Xt.$$.fragment),Zh=d(),$e=a("p"),Jh=n("This is the configuration class to store the configuration of a "),pn=a("a"),Xh=n("DetrModel"),em=n(`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),eo=a("a"),tm=n("facebook/detr-resnet-50"),om=n(" architecture."),nm=d(),Oe=a("p"),rm=n("Configuration objects inherit from "),fn=a("a"),am=n("PretrainedConfig"),sm=n(` and can be used to control the model outputs. Read the
documentation from `),un=a("a"),im=n("PretrainedConfig"),dm=n(" for more information."),cm=d(),b(Ge.$$.fragment),bs=d(),ze=a("h2"),Be=a("a"),Da=a("span"),b(to.$$.fragment),lm=d(),ya=a("span"),hm=n("DetrFeatureExtractor"),vs=d(),k=a("div"),b(oo.$$.fragment),mm=d(),wa=a("p"),pm=n("Constructs a DETR feature extractor."),fm=d(),no=a("p"),um=n("This feature extractor inherits from "),gn=a("a"),gm=n("FeatureExtractionMixin"),_m=n(` which contains most of the main methods. Users
should refer to this superclass for more information regarding those methods.`),bm=d(),ue=a("div"),b(ro.$$.fragment),vm=d(),xa=a("p"),Dm=n(`Main method to prepare for the model one or several image(s) and optional annotations. Images are by default
padded up to the largest image in a batch, and a pixel mask is created that indicates which pixels are
real/which are padding.`),ym=d(),b(Ve.$$.fragment),wm=d(),Ye=a("div"),b(ao.$$.fragment),xm=d(),so=a("p"),Tm=n("Pad images up to the largest image in a batch and create a corresponding "),Ta=a("code"),Em=n("pixel_mask"),Fm=n("."),km=d(),Qe=a("div"),b(io.$$.fragment),jm=d(),co=a("p"),$m=n("Converts the output of "),_n=a("a"),Om=n("DetrForObjectDetection"),zm=n(` into the format expected by the COCO api. Only supports
PyTorch.`),Cm=d(),Ke=a("div"),b(lo.$$.fragment),qm=d(),ho=a("p"),Pm=n("Converts the output of "),bn=a("a"),Nm=n("DetrForSegmentation"),Sm=n(" into semantic segmentation maps. Only supports PyTorch."),Am=d(),Ze=a("div"),b(mo.$$.fragment),Mm=d(),po=a("p"),Im=n("Converts the output of "),vn=a("a"),Lm=n("DetrForSegmentation"),Rm=n(" into instance segmentation predictions. Only supports PyTorch."),Hm=d(),Je=a("div"),b(fo.$$.fragment),Um=d(),uo=a("p"),Wm=n("Converts the output of "),Dn=a("a"),Gm=n("DetrForSegmentation"),Bm=n(` into image panoptic segmentation predictions. Only supports
PyTorch.`),Ds=d(),Ce=a("h2"),Xe=a("a"),Ea=a("span"),b(go.$$.fragment),Vm=d(),Fa=a("span"),Ym=n("DetrModel"),ys=d(),L=a("div"),b(_o.$$.fragment),Qm=d(),ka=a("p"),Km=n(`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Zm=d(),bo=a("p"),Jm=n("This model inherits from "),yn=a("a"),Xm=n("PreTrainedModel"),ep=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),tp=d(),vo=a("p"),op=n("This model is also a PyTorch "),Do=a("a"),np=n("torch.nn.Module"),rp=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ap=d(),K=a("div"),b(yo.$$.fragment),sp=d(),qe=a("p"),ip=n("The "),wn=a("a"),dp=n("DetrModel"),cp=n(" forward method, overrides the "),ja=a("code"),lp=n("__call__"),hp=n(" special method."),mp=d(),b(et.$$.fragment),pp=d(),b(tt.$$.fragment),ws=d(),Pe=a("h2"),ot=a("a"),$a=a("span"),b(wo.$$.fragment),fp=d(),Oa=a("span"),up=n("DetrForObjectDetection"),xs=d(),R=a("div"),b(xo.$$.fragment),gp=d(),za=a("p"),_p=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),bp=d(),To=a("p"),vp=n("This model inherits from "),xn=a("a"),Dp=n("PreTrainedModel"),yp=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),wp=d(),Eo=a("p"),xp=n("This model is also a PyTorch "),Fo=a("a"),Tp=n("torch.nn.Module"),Ep=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Fp=d(),Z=a("div"),b(ko.$$.fragment),kp=d(),Ne=a("p"),jp=n("The "),Tn=a("a"),$p=n("DetrForObjectDetection"),Op=n(" forward method, overrides the "),Ca=a("code"),zp=n("__call__"),Cp=n(" special method."),qp=d(),b(nt.$$.fragment),Pp=d(),b(rt.$$.fragment),Ts=d(),Se=a("h2"),at=a("a"),qa=a("span"),b(jo.$$.fragment),Np=d(),Pa=a("span"),Sp=n("DetrForSegmentation"),Es=d(),H=a("div"),b($o.$$.fragment),Ap=d(),Na=a("p"),Mp=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),Ip=d(),Oo=a("p"),Lp=n("This model inherits from "),En=a("a"),Rp=n("PreTrainedModel"),Hp=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Up=d(),zo=a("p"),Wp=n("This model is also a PyTorch "),Co=a("a"),Gp=n("torch.nn.Module"),Bp=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Vp=d(),J=a("div"),b(qo.$$.fragment),Yp=d(),Ae=a("p"),Qp=n("The "),Fn=a("a"),Kp=n("DetrForSegmentation"),Zp=n(" forward method, overrides the "),Sa=a("code"),Jp=n("__call__"),Xp=n(" special method."),ef=d(),b(st.$$.fragment),tf=d(),b(it.$$.fragment),this.h()},l(o){const h=f_('[data-svelte="svelte-1phssyn"]',document.head);f=s(h,"META",{name:!0,content:!0}),h.forEach(t),E=c(o),g=s(o,"H1",{class:!0});var Po=i(g);u=s(Po,"A",{id:!0,class:!0,href:!0});var Aa=i(u);T=s(Aa,"SPAN",{});var Ma=i(T);v(m.$$.fragment,Ma),Ma.forEach(t),Aa.forEach(t),_=c(Po),U=s(Po,"SPAN",{});var Ia=i(U);hi=r(Ia,"DETR"),Ia.forEach(t),Po.forEach(t),Ua=c(o),De=s(o,"H2",{class:!0});var No=i(De);Me=s(No,"A",{id:!0,class:!0,href:!0});var La=i(Me);An=s(La,"SPAN",{});var Ra=i(An);v(jt.$$.fragment,Ra),Ra.forEach(t),La.forEach(t),mi=c(No),Mn=s(No,"SPAN",{});var Ha=i(Mn);pi=r(Ha,"Overview"),Ha.forEach(t),No.forEach(t),Wa=c(o),Ie=s(o,"P",{});var ks=i(Ie);fi=r(ks,"The DETR model was proposed in "),$t=s(ks,"A",{href:!0,rel:!0});var nf=i($t);ui=r(nf,"End-to-End Object Detection with Transformers"),nf.forEach(t),gi=r(ks,` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),ks.forEach(t),Ga=c(o),Ao=s(o,"P",{});var rf=i(Ao);_i=r(rf,"The abstract from the paper is the following:"),rf.forEach(t),Ba=c(o),Mo=s(o,"P",{});var af=i(Mo);In=s(af,"EM",{});var sf=i(In);bi=r(sf,`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),sf.forEach(t),af.forEach(t),Va=c(o),fe=s(o,"P",{});var kn=i(fe);vi=r(kn,"This model was contributed by "),Ot=s(kn,"A",{href:!0,rel:!0});var df=i(Ot);Di=r(df,"nielsr"),df.forEach(t),yi=r(kn,". The original code can be found "),zt=s(kn,"A",{href:!0,rel:!0});var cf=i(zt);wi=r(cf,"here"),cf.forEach(t),xi=r(kn,"."),kn.forEach(t),Ya=c(o),Le=s(o,"P",{});var js=i(Le);Ti=r(js,"The quickest way to get started with DETR is by checking the "),Ct=s(js,"A",{href:!0,rel:!0});var lf=i(Ct);Ei=r(lf,"example notebooks"),lf.forEach(t),Fi=r(js,` (which showcase both inference and
fine-tuning on custom data).`),js.forEach(t),Qa=c(o),Re=s(o,"P",{});var $s=i(Re);ki=r($s,"Here\u2019s a TLDR explaining how "),Io=s($s,"A",{href:!0});var hf=i(Io);ji=r(hf,"DetrForObjectDetection"),hf.forEach(t),$i=r($s," works:"),$s.forEach(t),Ka=c(o),j=s(o,"P",{});var q=i(j);Oi=r(q,`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),Ln=s(q,"CODE",{});var mf=i(Ln);zi=r(mf,"(batch_size, 3, height, width)"),mf.forEach(t),Ci=r(q,`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),Rn=s(q,"CODE",{});var pf=i(Rn);qi=r(pf,"(batch_size, 2048, height/32, width/32)"),pf.forEach(t),Pi=r(q,`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),Hn=s(q,"CODE",{});var ff=i(Hn);Ni=r(ff,"256"),ff.forEach(t),Si=r(q,` by default, using a
`),Un=s(q,"CODE",{});var uf=i(Un);Ai=r(uf,"nn.Conv2D"),uf.forEach(t),Mi=r(q," layer. So now, we have a tensor of shape "),Wn=s(q,"CODE",{});var gf=i(Wn);Ii=r(gf,"(batch_size, 256, height/32, width/32)."),gf.forEach(t),Li=r(q,` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),Gn=s(q,"CODE",{});var _f=i(Gn);Ri=r(_f,"(batch_size, seq_len, d_model)"),_f.forEach(t),Hi=r(q,` =
`),Bn=s(q,"CODE",{});var bf=i(Bn);Ui=r(bf,"(batch_size, width/32*height/32, 256)"),bf.forEach(t),Wi=r(q,`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),Vn=s(q,"CODE",{});var vf=i(Vn);Gi=r(vf,"d_model"),vf.forEach(t),Bi=r(q," (which in NLP is typically 768 or higher)."),q.forEach(t),Za=c(o),C=s(o,"P",{});var W=i(C);Vi=r(W,"Next, this is sent through the encoder, outputting "),Yn=s(W,"CODE",{});var Df=i(Yn);Yi=r(Df,"encoder_hidden_states"),Df.forEach(t),Qi=r(W,` of the same shape (you can consider
these as image features). Next, so-called `),Qn=s(W,"STRONG",{});var yf=i(Qn);Ki=r(yf,"object queries"),yf.forEach(t),Zi=r(W,` are sent through the decoder. This is a tensor of shape
`),Kn=s(W,"CODE",{});var wf=i(Kn);Ji=r(wf,"(batch_size, num_queries, d_model)"),wf.forEach(t),Xi=r(W,", with "),Zn=s(W,"CODE",{});var xf=i(Zn);ed=r(xf,"num_queries"),xf.forEach(t),td=r(W,` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),Jn=s(W,"CODE",{});var Tf=i(Jn);od=r(Tf,"decoder_hidden_states"),Tf.forEach(t),nd=r(W," of the same shape: "),Xn=s(W,"CODE",{});var Ef=i(Xn);rd=r(Ef,"(batch_size, num_queries, d_model)"),Ef.forEach(t),ad=r(W,`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),W.forEach(t),Ja=c(o),Y=s(o,"P",{});var dt=i(Y);sd=r(dt,"The model is trained using a "),er=s(dt,"STRONG",{});var Ff=i(er);id=r(Ff,"bipartite matching loss"),Ff.forEach(t),dd=r(dt,`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),qt=s(dt,"A",{href:!0,rel:!0});var kf=i(qt);cd=r(kf,"Hungarian matching algorithm"),kf.forEach(t),ld=r(dt,` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Pt=s(dt,"A",{href:!0,rel:!0});var jf=i(Pt);hd=r(jf,"generalized IoU loss"),jf.forEach(t),md=r(dt,` (for the
bounding boxes) are used to optimize the parameters of the model.`),dt.forEach(t),Xa=c(o),Q=s(o,"P",{});var ct=i(Q);pd=r(ct,`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),Lo=s(ct,"A",{href:!0});var $f=i(Lo);fd=r($f,"DetrForSegmentation"),$f.forEach(t),ud=r(ct,` adds a segmentation mask head on top of
`),Ro=s(ct,"A",{href:!0});var Of=i(Ro);gd=r(Of,"DetrForObjectDetection"),Of.forEach(t),_d=r(ct,`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),Ho=s(ct,"A",{href:!0});var zf=i(Ho);bd=r(zf,"DetrForObjectDetection"),zf.forEach(t),vd=r(ct,` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),ct.forEach(t),es=c(o),Uo=s(o,"P",{});var Cf=i(Uo);Dd=r(Cf,"Tips:"),Cf.forEach(t),ts=c(o),$=s(o,"UL",{});var A=i($);te=s(A,"LI",{});var lt=i(te);yd=r(lt,"DETR uses so-called "),tr=s(lt,"STRONG",{});var qf=i(tr);wd=r(qf,"object queries"),qf.forEach(t),xd=r(lt,` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),or=s(lt,"CODE",{});var Pf=i(or);Td=r(Pf,"num_queries"),Pf.forEach(t),Ed=r(lt," of "),Wo=s(lt,"A",{href:!0});var Nf=i(Wo);Fd=r(Nf,"DetrConfig"),Nf.forEach(t),kd=r(lt,`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),lt.forEach(t),jd=c(A),nr=s(A,"LI",{});var Sf=i(nr);$d=r(Sf,`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),Sf.forEach(t),Od=c(A),oe=s(A,"LI",{});var ht=i(oe);zd=r(ht,`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),rr=s(ht,"CODE",{});var Af=i(rr);Cd=r(Af,"position_embedding_type"),Af.forEach(t),qd=r(ht,` of
`),Go=s(ht,"A",{href:!0});var Mf=i(Go);Pd=r(Mf,"DetrConfig"),Mf.forEach(t),Nd=r(ht," is set to "),ar=s(ht,"CODE",{});var If=i(ar);Sd=r(If,'"sine"'),If.forEach(t),Ad=r(ht,"."),ht.forEach(t),Md=c(A),ne=s(A,"LI",{});var mt=i(ne);Id=r(mt,`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),sr=s(mt,"CODE",{});var Lf=i(sr);Ld=r(Lf,"auxiliary_loss"),Lf.forEach(t),Rd=r(mt,` of
`),Bo=s(mt,"A",{href:!0});var Rf=i(Bo);Hd=r(Rf,"DetrConfig"),Rf.forEach(t),Ud=r(mt," to "),ir=s(mt,"CODE",{});var Hf=i(ir);Wd=r(Hf,"True"),Hf.forEach(t),Gd=r(mt,`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),mt.forEach(t),Bd=c(A),G=s(A,"LI",{});var ge=i(G);Vd=r(ge,`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),dr=s(ge,"EM",{});var Uf=i(dr);Yd=r(Uf,"num_boxes"),Uf.forEach(t),Qd=r(ge," variable in the "),cr=s(ge,"EM",{});var Wf=i(cr);Kd=r(Wf,"DetrLoss"),Wf.forEach(t),Zd=r(ge," class of "),lr=s(ge,"EM",{});var Gf=i(lr);Jd=r(Gf,"modeling_detr.py"),Gf.forEach(t),Xd=r(ge,`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Nt=s(ge,"A",{href:!0,rel:!0});var Bf=i(Nt);ec=r(Bf,"here"),Bf.forEach(t),tc=r(ge,"."),ge.forEach(t),oc=c(A),S=s(A,"LI",{});var V=i(S);Vo=s(V,"A",{href:!0});var Vf=i(Vo);nc=r(Vf,"DetrForObjectDetection"),Vf.forEach(t),rc=r(V," and "),Yo=s(V,"A",{href:!0});var Yf=i(Yo);ac=r(Yf,"DetrForSegmentation"),Yf.forEach(t),sc=r(V,` can be initialized with
any convolutional backbone available in the `),St=s(V,"A",{href:!0,rel:!0});var Qf=i(St);ic=r(Qf,"timm library"),Qf.forEach(t),dc=r(V,`.
Initializing with a MobileNet backbone for example can be done by setting the `),hr=s(V,"CODE",{});var Kf=i(hr);cc=r(Kf,"backbone"),Kf.forEach(t),lc=r(V,` attribute of
`),Qo=s(V,"A",{href:!0});var Zf=i(Qo);hc=r(Zf,"DetrConfig"),Zf.forEach(t),mc=r(V," to "),mr=s(V,"CODE",{});var Jf=i(mr);pc=r(Jf,'"tf_mobilenetv3_small_075"'),Jf.forEach(t),fc=r(V,`, and then initializing the model with that
config.`),V.forEach(t),uc=c(A),re=s(A,"LI",{});var pt=i(re);gc=r(pt,`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),Ko=s(pt,"A",{href:!0});var Xf=i(Ko);_c=r(Xf,"DetrFeatureExtractor"),Xf.forEach(t),bc=r(pt,` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),pr=s(pt,"CODE",{});var eu=i(pr);vc=r(eu,"collate_fn"),eu.forEach(t),Dc=r(pt,` in order to batch images together, using
`),Zo=s(pt,"A",{href:!0});var tu=i(Zo);yc=r(tu,"pad_and_create_pixel_mask()"),tu.forEach(t),wc=r(pt,"."),pt.forEach(t),xc=c(A),ye=s(A,"LI",{});var jn=i(ye);Tc=r(jn,"The size of the images will determine the amount of memory being used, and will thus determine the "),fr=s(jn,"CODE",{});var ou=i(fr);Ec=r(ou,"batch_size"),ou.forEach(t),Fc=r(jn,`.
It is advised to use a batch size of 2 per GPU. See `),At=s(jn,"A",{href:!0,rel:!0});var nu=i(At);kc=r(nu,"this Github thread"),nu.forEach(t),jc=r(jn," for more info."),jn.forEach(t),A.forEach(t),os=c(o),Jo=s(o,"P",{});var ru=i(Jo);$c=r(ru,"There are three ways to instantiate a DETR model (depending on what you prefer):"),ru.forEach(t),ns=c(o),Xo=s(o,"P",{});var au=i(Xo);Oc=r(au,"Option 1: Instantiate DETR with pre-trained weights for entire model"),au.forEach(t),rs=c(o),v(Mt.$$.fragment,o),as=c(o),en=s(o,"P",{});var su=i(en);zc=r(su,"Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),su.forEach(t),ss=c(o),v(It.$$.fragment,o),is=c(o),tn=s(o,"P",{});var iu=i(tn);Cc=r(iu,"Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),iu.forEach(t),ds=c(o),v(Lt.$$.fragment,o),cs=c(o),on=s(o,"P",{});var du=i(on);qc=r(du,"As a summary, consider the following table:"),du.forEach(t),ls=c(o),He=s(o,"TABLE",{});var Os=i(He);ur=s(Os,"THEAD",{});var cu=i(ur);ae=s(cu,"TR",{});var ft=i(ae);gr=s(ft,"TH",{});var lu=i(gr);Pc=r(lu,"Task"),lu.forEach(t),Nc=c(ft),_r=s(ft,"TH",{});var hu=i(_r);Sc=r(hu,"Object detection"),hu.forEach(t),Ac=c(ft),br=s(ft,"TH",{});var mu=i(br);Mc=r(mu,"Instance segmentation"),mu.forEach(t),Ic=c(ft),vr=s(ft,"TH",{});var pu=i(vr);Lc=r(pu,"Panoptic segmentation"),pu.forEach(t),ft.forEach(t),cu.forEach(t),Rc=c(Os),M=s(Os,"TBODY",{});var X=i(M);se=s(X,"TR",{});var ut=i(se);Dr=s(ut,"TD",{});var fu=i(Dr);yr=s(fu,"STRONG",{});var uu=i(yr);Hc=r(uu,"Description"),uu.forEach(t),fu.forEach(t),Uc=c(ut),wr=s(ut,"TD",{});var gu=i(wr);Wc=r(gu,"Predicting bounding boxes and class labels around objects in an image"),gu.forEach(t),Gc=c(ut),xr=s(ut,"TD",{});var _u=i(xr);Bc=r(_u,"Predicting masks around objects (i.e. instances) in an image"),_u.forEach(t),Vc=c(ut),Tr=s(ut,"TD",{});var bu=i(Tr);Yc=r(bu,"Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),bu.forEach(t),ut.forEach(t),Qc=c(X),ie=s(X,"TR",{});var gt=i(ie);Er=s(gt,"TD",{});var vu=i(Er);Fr=s(vu,"STRONG",{});var Du=i(Fr);Kc=r(Du,"Model"),Du.forEach(t),vu.forEach(t),Zc=c(gt),kr=s(gt,"TD",{});var yu=i(kr);nn=s(yu,"A",{href:!0});var wu=i(nn);Jc=r(wu,"DetrForObjectDetection"),wu.forEach(t),yu.forEach(t),Xc=c(gt),jr=s(gt,"TD",{});var xu=i(jr);rn=s(xu,"A",{href:!0});var Tu=i(rn);el=r(Tu,"DetrForSegmentation"),Tu.forEach(t),xu.forEach(t),tl=c(gt),$r=s(gt,"TD",{});var Eu=i($r);an=s(Eu,"A",{href:!0});var Fu=i(an);ol=r(Fu,"DetrForSegmentation"),Fu.forEach(t),Eu.forEach(t),gt.forEach(t),nl=c(X),de=s(X,"TR",{});var _t=i(de);Or=s(_t,"TD",{});var ku=i(Or);zr=s(ku,"STRONG",{});var ju=i(zr);rl=r(ju,"Example dataset"),ju.forEach(t),ku.forEach(t),al=c(_t),Cr=s(_t,"TD",{});var $u=i(Cr);sl=r($u,"COCO detection"),$u.forEach(t),il=c(_t),qr=s(_t,"TD",{});var Ou=i(qr);dl=r(Ou,"COCO detection, COCO panoptic"),Ou.forEach(t),cl=c(_t),Pr=s(_t,"TD",{});var zu=i(Pr);ll=r(zu,"COCO panoptic"),zu.forEach(t),_t.forEach(t),hl=c(X),ce=s(X,"TR",{});var bt=i(ce);Rt=s(bt,"TD",{});var zs=i(Rt);Nr=s(zs,"STRONG",{});var Cu=i(Nr);ml=r(Cu,"Format of annotations to provide to"),Cu.forEach(t),pl=c(zs),sn=s(zs,"A",{href:!0});var qu=i(sn);fl=r(qu,"DetrFeatureExtractor"),qu.forEach(t),zs.forEach(t),ul=c(bt),we=s(bt,"TD",{});var $n=i(we);gl=r($n,"{\u2018image_id\u2019: "),Sr=s($n,"CODE",{});var Pu=i(Sr);_l=r(Pu,"int"),Pu.forEach(t),bl=r($n,", \u2018annotations\u2019: "),Ar=s($n,"CODE",{});var Nu=i(Ar);vl=r(Nu,"List[Dict]"),Nu.forEach(t),Dl=r($n,"} each Dict being a COCO object annotation"),$n.forEach(t),yl=c(bt),I=s(bt,"TD",{});var ee=i(I);wl=r(ee,"{\u2018image_id\u2019: "),Mr=s(ee,"CODE",{});var Su=i(Mr);xl=r(Su,"int"),Su.forEach(t),Tl=r(ee,", \u2018annotations\u2019: "),Ir=s(ee,"CODE",{});var Au=i(Ir);El=r(Au,"List[Dict]"),Au.forEach(t),Fl=r(ee,"}  (in case of COCO detection) or {\u2018file_name\u2019: "),Lr=s(ee,"CODE",{});var Mu=i(Lr);kl=r(Mu,"str"),Mu.forEach(t),jl=r(ee,", \u2018image_id\u2019: "),Rr=s(ee,"CODE",{});var Iu=i(Rr);$l=r(Iu,"int"),Iu.forEach(t),Ol=r(ee,", \u2018segments_info\u2019: "),Hr=s(ee,"CODE",{});var Lu=i(Hr);zl=r(Lu,"List[Dict]"),Lu.forEach(t),Cl=r(ee,"} (in case of COCO panoptic)"),ee.forEach(t),ql=c(bt),le=s(bt,"TD",{});var vt=i(le);Pl=r(vt,"{\u2018file_name\u2019: "),Ur=s(vt,"CODE",{});var Ru=i(Ur);Nl=r(Ru,"str"),Ru.forEach(t),Sl=r(vt,", \u2018image_id\u2019: "),Wr=s(vt,"CODE",{});var Hu=i(Wr);Al=r(Hu,"int"),Hu.forEach(t),Ml=r(vt,", \u2018segments_info\u2019: "),Gr=s(vt,"CODE",{});var Uu=i(Gr);Il=r(Uu,"List[Dict]"),Uu.forEach(t),Ll=r(vt,"} and masks_path (path to directory containing PNG files of the masks)"),vt.forEach(t),bt.forEach(t),Rl=c(X),he=s(X,"TR",{});var Dt=i(he);dn=s(Dt,"TD",{});var of=i(dn);Br=s(of,"STRONG",{});var Wu=i(Br);Hl=r(Wu,"Postprocessing"),Wu.forEach(t),Ul=r(of," (i.e. converting the output of the model to COCO API)"),of.forEach(t),Wl=c(Dt),Vr=s(Dt,"TD",{});var Gu=i(Vr);Yr=s(Gu,"CODE",{});var Bu=i(Yr);Gl=r(Bu,"post_process()"),Bu.forEach(t),Gu.forEach(t),Bl=c(Dt),Qr=s(Dt,"TD",{});var Vu=i(Qr);Kr=s(Vu,"CODE",{});var Yu=i(Kr);Vl=r(Yu,"post_process_segmentation()"),Yu.forEach(t),Vu.forEach(t),Yl=c(Dt),Ht=s(Dt,"TD",{});var Cs=i(Ht);Zr=s(Cs,"CODE",{});var Qu=i(Zr);Ql=r(Qu,"post_process_segmentation()"),Qu.forEach(t),Kl=r(Cs,", "),Jr=s(Cs,"CODE",{});var Ku=i(Jr);Zl=r(Ku,"post_process_panoptic()"),Ku.forEach(t),Cs.forEach(t),Dt.forEach(t),Jl=c(X),me=s(X,"TR",{});var yt=i(me);Xr=s(yt,"TD",{});var Zu=i(Xr);ea=s(Zu,"STRONG",{});var Ju=i(ea);Xl=r(Ju,"evaluators"),Ju.forEach(t),Zu.forEach(t),eh=c(yt),Ut=s(yt,"TD",{});var qs=i(Ut);ta=s(qs,"CODE",{});var Xu=i(ta);th=r(Xu,"CocoEvaluator"),Xu.forEach(t),oh=r(qs," with "),oa=s(qs,"CODE",{});var eg=i(oa);nh=r(eg,'iou_types="bbox"'),eg.forEach(t),qs.forEach(t),rh=c(yt),xe=s(yt,"TD",{});var On=i(xe);na=s(On,"CODE",{});var tg=i(na);ah=r(tg,"CocoEvaluator"),tg.forEach(t),sh=r(On," with "),ra=s(On,"CODE",{});var og=i(ra);ih=r(og,'iou_types="bbox"'),og.forEach(t),dh=r(On," or "),aa=s(On,"CODE",{});var ng=i(aa);ch=r(ng,'"segm"'),ng.forEach(t),On.forEach(t),lh=c(yt),pe=s(yt,"TD",{});var wt=i(pe);sa=s(wt,"CODE",{});var rg=i(sa);hh=r(rg,"CocoEvaluator"),rg.forEach(t),mh=r(wt," with "),ia=s(wt,"CODE",{});var ag=i(ia);ph=r(ag,'iou_tupes="bbox"'),ag.forEach(t),fh=r(wt," or "),da=s(wt,"CODE",{});var sg=i(da);uh=r(sg,'"segm"'),sg.forEach(t),gh=r(wt,", "),ca=s(wt,"CODE",{});var ig=i(ca);_h=r(ig,"PanopticEvaluator"),ig.forEach(t),wt.forEach(t),yt.forEach(t),X.forEach(t),Os.forEach(t),hs=c(o),F=s(o,"P",{});var O=i(F);bh=r(O,`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),cn=s(O,"A",{href:!0});var dg=i(cn);vh=r(dg,"DetrFeatureExtractor"),dg.forEach(t),Dh=r(O," to create "),la=s(O,"CODE",{});var cg=i(la);yh=r(cg,"pixel_values"),cg.forEach(t),wh=r(O,", "),ha=s(O,"CODE",{});var lg=i(ha);xh=r(lg,"pixel_mask"),lg.forEach(t),Th=r(O,` and optional
`),ma=s(O,"CODE",{});var hg=i(ma);Eh=r(hg,"labels"),hg.forEach(t),Fh=r(O,`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),ln=s(O,"A",{href:!0});var mg=i(ln);kh=r(mg,"DetrFeatureExtractor"),mg.forEach(t),jh=r(O,`. These can
be be provided to either `),pa=s(O,"CODE",{});var pg=i(pa);$h=r(pg,"CocoEvaluator"),pg.forEach(t),Oh=r(O," or "),fa=s(O,"CODE",{});var fg=i(fa);zh=r(fg,"PanopticEvaluator"),fg.forEach(t),Ch=r(O,`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),Wt=s(O,"A",{href:!0,rel:!0});var ug=i(Wt);qh=r(ug,"original repository"),ug.forEach(t),Ph=r(O,". See the "),Gt=s(O,"A",{href:!0,rel:!0});var gg=i(Gt);Nh=r(gg,"example notebooks"),gg.forEach(t),Sh=r(O," for more info regarding evaluation."),O.forEach(t),ms=c(o),Te=s(o,"H2",{class:!0});var Ps=i(Te);Ue=s(Ps,"A",{id:!0,class:!0,href:!0});var _g=i(Ue);ua=s(_g,"SPAN",{});var bg=i(ua);v(Bt.$$.fragment,bg),bg.forEach(t),_g.forEach(t),Ah=c(Ps),ga=s(Ps,"SPAN",{});var vg=i(ga);Mh=r(vg,"DETR specific outputs"),vg.forEach(t),Ps.forEach(t),ps=c(o),Ee=s(o,"DIV",{class:!0});var Ns=i(Ee);v(Vt.$$.fragment,Ns),Ih=c(Ns),_a=s(Ns,"P",{});var Dg=i(_a);Lh=r(Dg,`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),Dg.forEach(t),Ns.forEach(t),fs=c(o),Fe=s(o,"DIV",{class:!0});var Ss=i(Fe);v(Yt.$$.fragment,Ss),Rh=c(Ss),Qt=s(Ss,"P",{});var As=i(Qt);Hh=r(As,"Output type of "),hn=s(As,"A",{href:!0});var yg=i(hn);Uh=r(yg,"DetrForObjectDetection"),yg.forEach(t),Wh=r(As,"."),As.forEach(t),Ss.forEach(t),us=c(o),ke=s(o,"DIV",{class:!0});var Ms=i(ke);v(Kt.$$.fragment,Ms),Gh=c(Ms),Zt=s(Ms,"P",{});var Is=i(Zt);Bh=r(Is,"Output type of "),mn=s(Is,"A",{href:!0});var wg=i(mn);Vh=r(wg,"DetrForSegmentation"),wg.forEach(t),Yh=r(Is,"."),Is.forEach(t),Ms.forEach(t),gs=c(o),je=s(o,"H2",{class:!0});var Ls=i(je);We=s(Ls,"A",{id:!0,class:!0,href:!0});var xg=i(We);ba=s(xg,"SPAN",{});var Tg=i(ba);v(Jt.$$.fragment,Tg),Tg.forEach(t),xg.forEach(t),Qh=c(Ls),va=s(Ls,"SPAN",{});var Eg=i(va);Kh=r(Eg,"DetrConfig"),Eg.forEach(t),Ls.forEach(t),_s=c(o),B=s(o,"DIV",{class:!0});var xt=i(B);v(Xt.$$.fragment,xt),Zh=c(xt),$e=s(xt,"P",{});var zn=i($e);Jh=r(zn,"This is the configuration class to store the configuration of a "),pn=s(zn,"A",{href:!0});var Fg=i(pn);Xh=r(Fg,"DetrModel"),Fg.forEach(t),em=r(zn,`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),eo=s(zn,"A",{href:!0,rel:!0});var kg=i(eo);tm=r(kg,"facebook/detr-resnet-50"),kg.forEach(t),om=r(zn," architecture."),zn.forEach(t),nm=c(xt),Oe=s(xt,"P",{});var Cn=i(Oe);rm=r(Cn,"Configuration objects inherit from "),fn=s(Cn,"A",{href:!0});var jg=i(fn);am=r(jg,"PretrainedConfig"),jg.forEach(t),sm=r(Cn,` and can be used to control the model outputs. Read the
documentation from `),un=s(Cn,"A",{href:!0});var $g=i(un);im=r($g,"PretrainedConfig"),$g.forEach(t),dm=r(Cn," for more information."),Cn.forEach(t),cm=c(xt),v(Ge.$$.fragment,xt),xt.forEach(t),bs=c(o),ze=s(o,"H2",{class:!0});var Rs=i(ze);Be=s(Rs,"A",{id:!0,class:!0,href:!0});var Og=i(Be);Da=s(Og,"SPAN",{});var zg=i(Da);v(to.$$.fragment,zg),zg.forEach(t),Og.forEach(t),lm=c(Rs),ya=s(Rs,"SPAN",{});var Cg=i(ya);hm=r(Cg,"DetrFeatureExtractor"),Cg.forEach(t),Rs.forEach(t),vs=c(o),k=s(o,"DIV",{class:!0});var P=i(k);v(oo.$$.fragment,P),mm=c(P),wa=s(P,"P",{});var qg=i(wa);pm=r(qg,"Constructs a DETR feature extractor."),qg.forEach(t),fm=c(P),no=s(P,"P",{});var Hs=i(no);um=r(Hs,"This feature extractor inherits from "),gn=s(Hs,"A",{href:!0});var Pg=i(gn);gm=r(Pg,"FeatureExtractionMixin"),Pg.forEach(t),_m=r(Hs,` which contains most of the main methods. Users
should refer to this superclass for more information regarding those methods.`),Hs.forEach(t),bm=c(P),ue=s(P,"DIV",{class:!0});var qn=i(ue);v(ro.$$.fragment,qn),vm=c(qn),xa=s(qn,"P",{});var Ng=i(xa);Dm=r(Ng,`Main method to prepare for the model one or several image(s) and optional annotations. Images are by default
padded up to the largest image in a batch, and a pixel mask is created that indicates which pixels are
real/which are padding.`),Ng.forEach(t),ym=c(qn),v(Ve.$$.fragment,qn),qn.forEach(t),wm=c(P),Ye=s(P,"DIV",{class:!0});var Us=i(Ye);v(ao.$$.fragment,Us),xm=c(Us),so=s(Us,"P",{});var Ws=i(so);Tm=r(Ws,"Pad images up to the largest image in a batch and create a corresponding "),Ta=s(Ws,"CODE",{});var Sg=i(Ta);Em=r(Sg,"pixel_mask"),Sg.forEach(t),Fm=r(Ws,"."),Ws.forEach(t),Us.forEach(t),km=c(P),Qe=s(P,"DIV",{class:!0});var Gs=i(Qe);v(io.$$.fragment,Gs),jm=c(Gs),co=s(Gs,"P",{});var Bs=i(co);$m=r(Bs,"Converts the output of "),_n=s(Bs,"A",{href:!0});var Ag=i(_n);Om=r(Ag,"DetrForObjectDetection"),Ag.forEach(t),zm=r(Bs,` into the format expected by the COCO api. Only supports
PyTorch.`),Bs.forEach(t),Gs.forEach(t),Cm=c(P),Ke=s(P,"DIV",{class:!0});var Vs=i(Ke);v(lo.$$.fragment,Vs),qm=c(Vs),ho=s(Vs,"P",{});var Ys=i(ho);Pm=r(Ys,"Converts the output of "),bn=s(Ys,"A",{href:!0});var Mg=i(bn);Nm=r(Mg,"DetrForSegmentation"),Mg.forEach(t),Sm=r(Ys," into semantic segmentation maps. Only supports PyTorch."),Ys.forEach(t),Vs.forEach(t),Am=c(P),Ze=s(P,"DIV",{class:!0});var Qs=i(Ze);v(mo.$$.fragment,Qs),Mm=c(Qs),po=s(Qs,"P",{});var Ks=i(po);Im=r(Ks,"Converts the output of "),vn=s(Ks,"A",{href:!0});var Ig=i(vn);Lm=r(Ig,"DetrForSegmentation"),Ig.forEach(t),Rm=r(Ks," into instance segmentation predictions. Only supports PyTorch."),Ks.forEach(t),Qs.forEach(t),Hm=c(P),Je=s(P,"DIV",{class:!0});var Zs=i(Je);v(fo.$$.fragment,Zs),Um=c(Zs),uo=s(Zs,"P",{});var Js=i(uo);Wm=r(Js,"Converts the output of "),Dn=s(Js,"A",{href:!0});var Lg=i(Dn);Gm=r(Lg,"DetrForSegmentation"),Lg.forEach(t),Bm=r(Js,` into image panoptic segmentation predictions. Only supports
PyTorch.`),Js.forEach(t),Zs.forEach(t),P.forEach(t),Ds=c(o),Ce=s(o,"H2",{class:!0});var Xs=i(Ce);Xe=s(Xs,"A",{id:!0,class:!0,href:!0});var Rg=i(Xe);Ea=s(Rg,"SPAN",{});var Hg=i(Ea);v(go.$$.fragment,Hg),Hg.forEach(t),Rg.forEach(t),Vm=c(Xs),Fa=s(Xs,"SPAN",{});var Ug=i(Fa);Ym=r(Ug,"DetrModel"),Ug.forEach(t),Xs.forEach(t),ys=c(o),L=s(o,"DIV",{class:!0});var _e=i(L);v(_o.$$.fragment,_e),Qm=c(_e),ka=s(_e,"P",{});var Wg=i(ka);Km=r(Wg,`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),Wg.forEach(t),Zm=c(_e),bo=s(_e,"P",{});var ei=i(bo);Jm=r(ei,"This model inherits from "),yn=s(ei,"A",{href:!0});var Gg=i(yn);Xm=r(Gg,"PreTrainedModel"),Gg.forEach(t),ep=r(ei,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ei.forEach(t),tp=c(_e),vo=s(_e,"P",{});var ti=i(vo);op=r(ti,"This model is also a PyTorch "),Do=s(ti,"A",{href:!0,rel:!0});var Bg=i(Do);np=r(Bg,"torch.nn.Module"),Bg.forEach(t),rp=r(ti,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ti.forEach(t),ap=c(_e),K=s(_e,"DIV",{class:!0});var Tt=i(K);v(yo.$$.fragment,Tt),sp=c(Tt),qe=s(Tt,"P",{});var Pn=i(qe);ip=r(Pn,"The "),wn=s(Pn,"A",{href:!0});var Vg=i(wn);dp=r(Vg,"DetrModel"),Vg.forEach(t),cp=r(Pn," forward method, overrides the "),ja=s(Pn,"CODE",{});var Yg=i(ja);lp=r(Yg,"__call__"),Yg.forEach(t),hp=r(Pn," special method."),Pn.forEach(t),mp=c(Tt),v(et.$$.fragment,Tt),pp=c(Tt),v(tt.$$.fragment,Tt),Tt.forEach(t),_e.forEach(t),ws=c(o),Pe=s(o,"H2",{class:!0});var oi=i(Pe);ot=s(oi,"A",{id:!0,class:!0,href:!0});var Qg=i(ot);$a=s(Qg,"SPAN",{});var Kg=i($a);v(wo.$$.fragment,Kg),Kg.forEach(t),Qg.forEach(t),fp=c(oi),Oa=s(oi,"SPAN",{});var Zg=i(Oa);up=r(Zg,"DetrForObjectDetection"),Zg.forEach(t),oi.forEach(t),xs=c(o),R=s(o,"DIV",{class:!0});var be=i(R);v(xo.$$.fragment,be),gp=c(be),za=s(be,"P",{});var Jg=i(za);_p=r(Jg,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),Jg.forEach(t),bp=c(be),To=s(be,"P",{});var ni=i(To);vp=r(ni,"This model inherits from "),xn=s(ni,"A",{href:!0});var Xg=i(xn);Dp=r(Xg,"PreTrainedModel"),Xg.forEach(t),yp=r(ni,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ni.forEach(t),wp=c(be),Eo=s(be,"P",{});var ri=i(Eo);xp=r(ri,"This model is also a PyTorch "),Fo=s(ri,"A",{href:!0,rel:!0});var e_=i(Fo);Tp=r(e_,"torch.nn.Module"),e_.forEach(t),Ep=r(ri,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ri.forEach(t),Fp=c(be),Z=s(be,"DIV",{class:!0});var Et=i(Z);v(ko.$$.fragment,Et),kp=c(Et),Ne=s(Et,"P",{});var Nn=i(Ne);jp=r(Nn,"The "),Tn=s(Nn,"A",{href:!0});var t_=i(Tn);$p=r(t_,"DetrForObjectDetection"),t_.forEach(t),Op=r(Nn," forward method, overrides the "),Ca=s(Nn,"CODE",{});var o_=i(Ca);zp=r(o_,"__call__"),o_.forEach(t),Cp=r(Nn," special method."),Nn.forEach(t),qp=c(Et),v(nt.$$.fragment,Et),Pp=c(Et),v(rt.$$.fragment,Et),Et.forEach(t),be.forEach(t),Ts=c(o),Se=s(o,"H2",{class:!0});var ai=i(Se);at=s(ai,"A",{id:!0,class:!0,href:!0});var n_=i(at);qa=s(n_,"SPAN",{});var r_=i(qa);v(jo.$$.fragment,r_),r_.forEach(t),n_.forEach(t),Np=c(ai),Pa=s(ai,"SPAN",{});var a_=i(Pa);Sp=r(a_,"DetrForSegmentation"),a_.forEach(t),ai.forEach(t),Es=c(o),H=s(o,"DIV",{class:!0});var ve=i(H);v($o.$$.fragment,ve),Ap=c(ve),Na=s(ve,"P",{});var s_=i(Na);Mp=r(s_,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),s_.forEach(t),Ip=c(ve),Oo=s(ve,"P",{});var si=i(Oo);Lp=r(si,"This model inherits from "),En=s(si,"A",{href:!0});var i_=i(En);Rp=r(i_,"PreTrainedModel"),i_.forEach(t),Hp=r(si,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),si.forEach(t),Up=c(ve),zo=s(ve,"P",{});var ii=i(zo);Wp=r(ii,"This model is also a PyTorch "),Co=s(ii,"A",{href:!0,rel:!0});var d_=i(Co);Gp=r(d_,"torch.nn.Module"),d_.forEach(t),Bp=r(ii,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),ii.forEach(t),Vp=c(ve),J=s(ve,"DIV",{class:!0});var Ft=i(J);v(qo.$$.fragment,Ft),Yp=c(Ft),Ae=s(Ft,"P",{});var Sn=i(Ae);Qp=r(Sn,"The "),Fn=s(Sn,"A",{href:!0});var c_=i(Fn);Kp=r(c_,"DetrForSegmentation"),c_.forEach(t),Zp=r(Sn," forward method, overrides the "),Sa=s(Sn,"CODE",{});var l_=i(Sa);Jp=r(l_,"__call__"),l_.forEach(t),Xp=r(Sn," special method."),Sn.forEach(t),ef=c(Ft),v(st.$$.fragment,Ft),tf=c(Ft),v(it.$$.fragment,Ft),Ft.forEach(t),ve.forEach(t),this.h()},h(){l(f,"name","hf:doc:metadata"),l(f,"content",JSON.stringify(E_)),l(u,"id","detr"),l(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(u,"href","#detr"),l(g,"class","relative group"),l(Me,"id","overview"),l(Me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Me,"href","#overview"),l(De,"class","relative group"),l($t,"href","https://arxiv.org/abs/2005.12872"),l($t,"rel","nofollow"),l(Ot,"href","https://huggingface.co/nielsr"),l(Ot,"rel","nofollow"),l(zt,"href","https://github.com/facebookresearch/detr"),l(zt,"rel","nofollow"),l(Ct,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(Ct,"rel","nofollow"),l(Io,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(qt,"href","https://en.wikipedia.org/wiki/Hungarian_algorithm"),l(qt,"rel","nofollow"),l(Pt,"href","https://giou.stanford.edu/"),l(Pt,"rel","nofollow"),l(Lo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Ro,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Ho,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Wo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(Go,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(Bo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(Nt,"href","https://github.com/facebookresearch/detr/blob/a54b77800eb8e64e3ad0d8237789fcbf2f8350c5/models/detr.py#L227-L232"),l(Nt,"rel","nofollow"),l(Vo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Yo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(St,"href","https://github.com/rwightman/pytorch-image-models"),l(St,"rel","nofollow"),l(Qo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrConfig"),l(Ko,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor"),l(Zo,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor.pad_and_create_pixel_mask"),l(At,"href","https://github.com/facebookresearch/detr/issues/150"),l(At,"rel","nofollow"),l(nn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(rn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(an,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(sn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor"),l(cn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor"),l(ln,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrFeatureExtractor"),l(Wt,"href","https://github.com/facebookresearch/detr"),l(Wt,"rel","nofollow"),l(Gt,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(Gt,"rel","nofollow"),l(Ue,"id","transformers.models.detr.modeling_detr.DetrModelOutput"),l(Ue,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ue,"href","#transformers.models.detr.modeling_detr.DetrModelOutput"),l(Te,"class","relative group"),l(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(hn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(mn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(We,"id","transformers.DetrConfig"),l(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(We,"href","#transformers.DetrConfig"),l(je,"class","relative group"),l(pn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrModel"),l(eo,"href","https://huggingface.co/facebook/detr-resnet-50"),l(eo,"rel","nofollow"),l(fn,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(un,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),l(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Be,"id","transformers.DetrFeatureExtractor"),l(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Be,"href","#transformers.DetrFeatureExtractor"),l(ze,"class","relative group"),l(gn,"href","/docs/transformers/main/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin"),l(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(_n,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(bn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(vn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Dn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(Je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Xe,"id","transformers.DetrModel"),l(Xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Xe,"href","#transformers.DetrModel"),l(Ce,"class","relative group"),l(yn,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Do,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Do,"rel","nofollow"),l(wn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrModel"),l(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(ot,"id","transformers.DetrForObjectDetection"),l(ot,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ot,"href","#transformers.DetrForObjectDetection"),l(Pe,"class","relative group"),l(xn,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Fo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Fo,"rel","nofollow"),l(Tn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(at,"id","transformers.DetrForSegmentation"),l(at,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(at,"href","#transformers.DetrForSegmentation"),l(Se,"class","relative group"),l(En,"href","/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel"),l(Co,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Co,"rel","nofollow"),l(Fn,"href","/docs/transformers/main/en/model_doc/detr#transformers.DetrForSegmentation"),l(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,h){e(document.head,f),p(o,E,h),p(o,g,h),e(g,u),e(u,T),D(m,T,null),e(g,_),e(g,U),e(U,hi),p(o,Ua,h),p(o,De,h),e(De,Me),e(Me,An),D(jt,An,null),e(De,mi),e(De,Mn),e(Mn,pi),p(o,Wa,h),p(o,Ie,h),e(Ie,fi),e(Ie,$t),e($t,ui),e(Ie,gi),p(o,Ga,h),p(o,Ao,h),e(Ao,_i),p(o,Ba,h),p(o,Mo,h),e(Mo,In),e(In,bi),p(o,Va,h),p(o,fe,h),e(fe,vi),e(fe,Ot),e(Ot,Di),e(fe,yi),e(fe,zt),e(zt,wi),e(fe,xi),p(o,Ya,h),p(o,Le,h),e(Le,Ti),e(Le,Ct),e(Ct,Ei),e(Le,Fi),p(o,Qa,h),p(o,Re,h),e(Re,ki),e(Re,Io),e(Io,ji),e(Re,$i),p(o,Ka,h),p(o,j,h),e(j,Oi),e(j,Ln),e(Ln,zi),e(j,Ci),e(j,Rn),e(Rn,qi),e(j,Pi),e(j,Hn),e(Hn,Ni),e(j,Si),e(j,Un),e(Un,Ai),e(j,Mi),e(j,Wn),e(Wn,Ii),e(j,Li),e(j,Gn),e(Gn,Ri),e(j,Hi),e(j,Bn),e(Bn,Ui),e(j,Wi),e(j,Vn),e(Vn,Gi),e(j,Bi),p(o,Za,h),p(o,C,h),e(C,Vi),e(C,Yn),e(Yn,Yi),e(C,Qi),e(C,Qn),e(Qn,Ki),e(C,Zi),e(C,Kn),e(Kn,Ji),e(C,Xi),e(C,Zn),e(Zn,ed),e(C,td),e(C,Jn),e(Jn,od),e(C,nd),e(C,Xn),e(Xn,rd),e(C,ad),p(o,Ja,h),p(o,Y,h),e(Y,sd),e(Y,er),e(er,id),e(Y,dd),e(Y,qt),e(qt,cd),e(Y,ld),e(Y,Pt),e(Pt,hd),e(Y,md),p(o,Xa,h),p(o,Q,h),e(Q,pd),e(Q,Lo),e(Lo,fd),e(Q,ud),e(Q,Ro),e(Ro,gd),e(Q,_d),e(Q,Ho),e(Ho,bd),e(Q,vd),p(o,es,h),p(o,Uo,h),e(Uo,Dd),p(o,ts,h),p(o,$,h),e($,te),e(te,yd),e(te,tr),e(tr,wd),e(te,xd),e(te,or),e(or,Td),e(te,Ed),e(te,Wo),e(Wo,Fd),e(te,kd),e($,jd),e($,nr),e(nr,$d),e($,Od),e($,oe),e(oe,zd),e(oe,rr),e(rr,Cd),e(oe,qd),e(oe,Go),e(Go,Pd),e(oe,Nd),e(oe,ar),e(ar,Sd),e(oe,Ad),e($,Md),e($,ne),e(ne,Id),e(ne,sr),e(sr,Ld),e(ne,Rd),e(ne,Bo),e(Bo,Hd),e(ne,Ud),e(ne,ir),e(ir,Wd),e(ne,Gd),e($,Bd),e($,G),e(G,Vd),e(G,dr),e(dr,Yd),e(G,Qd),e(G,cr),e(cr,Kd),e(G,Zd),e(G,lr),e(lr,Jd),e(G,Xd),e(G,Nt),e(Nt,ec),e(G,tc),e($,oc),e($,S),e(S,Vo),e(Vo,nc),e(S,rc),e(S,Yo),e(Yo,ac),e(S,sc),e(S,St),e(St,ic),e(S,dc),e(S,hr),e(hr,cc),e(S,lc),e(S,Qo),e(Qo,hc),e(S,mc),e(S,mr),e(mr,pc),e(S,fc),e($,uc),e($,re),e(re,gc),e(re,Ko),e(Ko,_c),e(re,bc),e(re,pr),e(pr,vc),e(re,Dc),e(re,Zo),e(Zo,yc),e(re,wc),e($,xc),e($,ye),e(ye,Tc),e(ye,fr),e(fr,Ec),e(ye,Fc),e(ye,At),e(At,kc),e(ye,jc),p(o,os,h),p(o,Jo,h),e(Jo,$c),p(o,ns,h),p(o,Xo,h),e(Xo,Oc),p(o,rs,h),D(Mt,o,h),p(o,as,h),p(o,en,h),e(en,zc),p(o,ss,h),D(It,o,h),p(o,is,h),p(o,tn,h),e(tn,Cc),p(o,ds,h),D(Lt,o,h),p(o,cs,h),p(o,on,h),e(on,qc),p(o,ls,h),p(o,He,h),e(He,ur),e(ur,ae),e(ae,gr),e(gr,Pc),e(ae,Nc),e(ae,_r),e(_r,Sc),e(ae,Ac),e(ae,br),e(br,Mc),e(ae,Ic),e(ae,vr),e(vr,Lc),e(He,Rc),e(He,M),e(M,se),e(se,Dr),e(Dr,yr),e(yr,Hc),e(se,Uc),e(se,wr),e(wr,Wc),e(se,Gc),e(se,xr),e(xr,Bc),e(se,Vc),e(se,Tr),e(Tr,Yc),e(M,Qc),e(M,ie),e(ie,Er),e(Er,Fr),e(Fr,Kc),e(ie,Zc),e(ie,kr),e(kr,nn),e(nn,Jc),e(ie,Xc),e(ie,jr),e(jr,rn),e(rn,el),e(ie,tl),e(ie,$r),e($r,an),e(an,ol),e(M,nl),e(M,de),e(de,Or),e(Or,zr),e(zr,rl),e(de,al),e(de,Cr),e(Cr,sl),e(de,il),e(de,qr),e(qr,dl),e(de,cl),e(de,Pr),e(Pr,ll),e(M,hl),e(M,ce),e(ce,Rt),e(Rt,Nr),e(Nr,ml),e(Rt,pl),e(Rt,sn),e(sn,fl),e(ce,ul),e(ce,we),e(we,gl),e(we,Sr),e(Sr,_l),e(we,bl),e(we,Ar),e(Ar,vl),e(we,Dl),e(ce,yl),e(ce,I),e(I,wl),e(I,Mr),e(Mr,xl),e(I,Tl),e(I,Ir),e(Ir,El),e(I,Fl),e(I,Lr),e(Lr,kl),e(I,jl),e(I,Rr),e(Rr,$l),e(I,Ol),e(I,Hr),e(Hr,zl),e(I,Cl),e(ce,ql),e(ce,le),e(le,Pl),e(le,Ur),e(Ur,Nl),e(le,Sl),e(le,Wr),e(Wr,Al),e(le,Ml),e(le,Gr),e(Gr,Il),e(le,Ll),e(M,Rl),e(M,he),e(he,dn),e(dn,Br),e(Br,Hl),e(dn,Ul),e(he,Wl),e(he,Vr),e(Vr,Yr),e(Yr,Gl),e(he,Bl),e(he,Qr),e(Qr,Kr),e(Kr,Vl),e(he,Yl),e(he,Ht),e(Ht,Zr),e(Zr,Ql),e(Ht,Kl),e(Ht,Jr),e(Jr,Zl),e(M,Jl),e(M,me),e(me,Xr),e(Xr,ea),e(ea,Xl),e(me,eh),e(me,Ut),e(Ut,ta),e(ta,th),e(Ut,oh),e(Ut,oa),e(oa,nh),e(me,rh),e(me,xe),e(xe,na),e(na,ah),e(xe,sh),e(xe,ra),e(ra,ih),e(xe,dh),e(xe,aa),e(aa,ch),e(me,lh),e(me,pe),e(pe,sa),e(sa,hh),e(pe,mh),e(pe,ia),e(ia,ph),e(pe,fh),e(pe,da),e(da,uh),e(pe,gh),e(pe,ca),e(ca,_h),p(o,hs,h),p(o,F,h),e(F,bh),e(F,cn),e(cn,vh),e(F,Dh),e(F,la),e(la,yh),e(F,wh),e(F,ha),e(ha,xh),e(F,Th),e(F,ma),e(ma,Eh),e(F,Fh),e(F,ln),e(ln,kh),e(F,jh),e(F,pa),e(pa,$h),e(F,Oh),e(F,fa),e(fa,zh),e(F,Ch),e(F,Wt),e(Wt,qh),e(F,Ph),e(F,Gt),e(Gt,Nh),e(F,Sh),p(o,ms,h),p(o,Te,h),e(Te,Ue),e(Ue,ua),D(Bt,ua,null),e(Te,Ah),e(Te,ga),e(ga,Mh),p(o,ps,h),p(o,Ee,h),D(Vt,Ee,null),e(Ee,Ih),e(Ee,_a),e(_a,Lh),p(o,fs,h),p(o,Fe,h),D(Yt,Fe,null),e(Fe,Rh),e(Fe,Qt),e(Qt,Hh),e(Qt,hn),e(hn,Uh),e(Qt,Wh),p(o,us,h),p(o,ke,h),D(Kt,ke,null),e(ke,Gh),e(ke,Zt),e(Zt,Bh),e(Zt,mn),e(mn,Vh),e(Zt,Yh),p(o,gs,h),p(o,je,h),e(je,We),e(We,ba),D(Jt,ba,null),e(je,Qh),e(je,va),e(va,Kh),p(o,_s,h),p(o,B,h),D(Xt,B,null),e(B,Zh),e(B,$e),e($e,Jh),e($e,pn),e(pn,Xh),e($e,em),e($e,eo),e(eo,tm),e($e,om),e(B,nm),e(B,Oe),e(Oe,rm),e(Oe,fn),e(fn,am),e(Oe,sm),e(Oe,un),e(un,im),e(Oe,dm),e(B,cm),D(Ge,B,null),p(o,bs,h),p(o,ze,h),e(ze,Be),e(Be,Da),D(to,Da,null),e(ze,lm),e(ze,ya),e(ya,hm),p(o,vs,h),p(o,k,h),D(oo,k,null),e(k,mm),e(k,wa),e(wa,pm),e(k,fm),e(k,no),e(no,um),e(no,gn),e(gn,gm),e(no,_m),e(k,bm),e(k,ue),D(ro,ue,null),e(ue,vm),e(ue,xa),e(xa,Dm),e(ue,ym),D(Ve,ue,null),e(k,wm),e(k,Ye),D(ao,Ye,null),e(Ye,xm),e(Ye,so),e(so,Tm),e(so,Ta),e(Ta,Em),e(so,Fm),e(k,km),e(k,Qe),D(io,Qe,null),e(Qe,jm),e(Qe,co),e(co,$m),e(co,_n),e(_n,Om),e(co,zm),e(k,Cm),e(k,Ke),D(lo,Ke,null),e(Ke,qm),e(Ke,ho),e(ho,Pm),e(ho,bn),e(bn,Nm),e(ho,Sm),e(k,Am),e(k,Ze),D(mo,Ze,null),e(Ze,Mm),e(Ze,po),e(po,Im),e(po,vn),e(vn,Lm),e(po,Rm),e(k,Hm),e(k,Je),D(fo,Je,null),e(Je,Um),e(Je,uo),e(uo,Wm),e(uo,Dn),e(Dn,Gm),e(uo,Bm),p(o,Ds,h),p(o,Ce,h),e(Ce,Xe),e(Xe,Ea),D(go,Ea,null),e(Ce,Vm),e(Ce,Fa),e(Fa,Ym),p(o,ys,h),p(o,L,h),D(_o,L,null),e(L,Qm),e(L,ka),e(ka,Km),e(L,Zm),e(L,bo),e(bo,Jm),e(bo,yn),e(yn,Xm),e(bo,ep),e(L,tp),e(L,vo),e(vo,op),e(vo,Do),e(Do,np),e(vo,rp),e(L,ap),e(L,K),D(yo,K,null),e(K,sp),e(K,qe),e(qe,ip),e(qe,wn),e(wn,dp),e(qe,cp),e(qe,ja),e(ja,lp),e(qe,hp),e(K,mp),D(et,K,null),e(K,pp),D(tt,K,null),p(o,ws,h),p(o,Pe,h),e(Pe,ot),e(ot,$a),D(wo,$a,null),e(Pe,fp),e(Pe,Oa),e(Oa,up),p(o,xs,h),p(o,R,h),D(xo,R,null),e(R,gp),e(R,za),e(za,_p),e(R,bp),e(R,To),e(To,vp),e(To,xn),e(xn,Dp),e(To,yp),e(R,wp),e(R,Eo),e(Eo,xp),e(Eo,Fo),e(Fo,Tp),e(Eo,Ep),e(R,Fp),e(R,Z),D(ko,Z,null),e(Z,kp),e(Z,Ne),e(Ne,jp),e(Ne,Tn),e(Tn,$p),e(Ne,Op),e(Ne,Ca),e(Ca,zp),e(Ne,Cp),e(Z,qp),D(nt,Z,null),e(Z,Pp),D(rt,Z,null),p(o,Ts,h),p(o,Se,h),e(Se,at),e(at,qa),D(jo,qa,null),e(Se,Np),e(Se,Pa),e(Pa,Sp),p(o,Es,h),p(o,H,h),D($o,H,null),e(H,Ap),e(H,Na),e(Na,Mp),e(H,Ip),e(H,Oo),e(Oo,Lp),e(Oo,En),e(En,Rp),e(Oo,Hp),e(H,Up),e(H,zo),e(zo,Wp),e(zo,Co),e(Co,Gp),e(zo,Bp),e(H,Vp),e(H,J),D(qo,J,null),e(J,Yp),e(J,Ae),e(Ae,Qp),e(Ae,Fn),e(Fn,Kp),e(Ae,Zp),e(Ae,Sa),e(Sa,Jp),e(Ae,Xp),e(J,ef),D(st,J,null),e(J,tf),D(it,J,null),Fs=!0},p(o,[h]){const Po={};h&2&&(Po.$$scope={dirty:h,ctx:o}),Ge.$set(Po);const Aa={};h&2&&(Aa.$$scope={dirty:h,ctx:o}),Ve.$set(Aa);const Ma={};h&2&&(Ma.$$scope={dirty:h,ctx:o}),et.$set(Ma);const Ia={};h&2&&(Ia.$$scope={dirty:h,ctx:o}),tt.$set(Ia);const No={};h&2&&(No.$$scope={dirty:h,ctx:o}),nt.$set(No);const La={};h&2&&(La.$$scope={dirty:h,ctx:o}),rt.$set(La);const Ra={};h&2&&(Ra.$$scope={dirty:h,ctx:o}),st.$set(Ra);const Ha={};h&2&&(Ha.$$scope={dirty:h,ctx:o}),it.$set(Ha)},i(o){Fs||(y(m.$$.fragment,o),y(jt.$$.fragment,o),y(Mt.$$.fragment,o),y(It.$$.fragment,o),y(Lt.$$.fragment,o),y(Bt.$$.fragment,o),y(Vt.$$.fragment,o),y(Yt.$$.fragment,o),y(Kt.$$.fragment,o),y(Jt.$$.fragment,o),y(Xt.$$.fragment,o),y(Ge.$$.fragment,o),y(to.$$.fragment,o),y(oo.$$.fragment,o),y(ro.$$.fragment,o),y(Ve.$$.fragment,o),y(ao.$$.fragment,o),y(io.$$.fragment,o),y(lo.$$.fragment,o),y(mo.$$.fragment,o),y(fo.$$.fragment,o),y(go.$$.fragment,o),y(_o.$$.fragment,o),y(yo.$$.fragment,o),y(et.$$.fragment,o),y(tt.$$.fragment,o),y(wo.$$.fragment,o),y(xo.$$.fragment,o),y(ko.$$.fragment,o),y(nt.$$.fragment,o),y(rt.$$.fragment,o),y(jo.$$.fragment,o),y($o.$$.fragment,o),y(qo.$$.fragment,o),y(st.$$.fragment,o),y(it.$$.fragment,o),Fs=!0)},o(o){w(m.$$.fragment,o),w(jt.$$.fragment,o),w(Mt.$$.fragment,o),w(It.$$.fragment,o),w(Lt.$$.fragment,o),w(Bt.$$.fragment,o),w(Vt.$$.fragment,o),w(Yt.$$.fragment,o),w(Kt.$$.fragment,o),w(Jt.$$.fragment,o),w(Xt.$$.fragment,o),w(Ge.$$.fragment,o),w(to.$$.fragment,o),w(oo.$$.fragment,o),w(ro.$$.fragment,o),w(Ve.$$.fragment,o),w(ao.$$.fragment,o),w(io.$$.fragment,o),w(lo.$$.fragment,o),w(mo.$$.fragment,o),w(fo.$$.fragment,o),w(go.$$.fragment,o),w(_o.$$.fragment,o),w(yo.$$.fragment,o),w(et.$$.fragment,o),w(tt.$$.fragment,o),w(wo.$$.fragment,o),w(xo.$$.fragment,o),w(ko.$$.fragment,o),w(nt.$$.fragment,o),w(rt.$$.fragment,o),w(jo.$$.fragment,o),w($o.$$.fragment,o),w(qo.$$.fragment,o),w(st.$$.fragment,o),w(it.$$.fragment,o),Fs=!1},d(o){t(f),o&&t(E),o&&t(g),x(m),o&&t(Ua),o&&t(De),x(jt),o&&t(Wa),o&&t(Ie),o&&t(Ga),o&&t(Ao),o&&t(Ba),o&&t(Mo),o&&t(Va),o&&t(fe),o&&t(Ya),o&&t(Le),o&&t(Qa),o&&t(Re),o&&t(Ka),o&&t(j),o&&t(Za),o&&t(C),o&&t(Ja),o&&t(Y),o&&t(Xa),o&&t(Q),o&&t(es),o&&t(Uo),o&&t(ts),o&&t($),o&&t(os),o&&t(Jo),o&&t(ns),o&&t(Xo),o&&t(rs),x(Mt,o),o&&t(as),o&&t(en),o&&t(ss),x(It,o),o&&t(is),o&&t(tn),o&&t(ds),x(Lt,o),o&&t(cs),o&&t(on),o&&t(ls),o&&t(He),o&&t(hs),o&&t(F),o&&t(ms),o&&t(Te),x(Bt),o&&t(ps),o&&t(Ee),x(Vt),o&&t(fs),o&&t(Fe),x(Yt),o&&t(us),o&&t(ke),x(Kt),o&&t(gs),o&&t(je),x(Jt),o&&t(_s),o&&t(B),x(Xt),x(Ge),o&&t(bs),o&&t(ze),x(to),o&&t(vs),o&&t(k),x(oo),x(ro),x(Ve),x(ao),x(io),x(lo),x(mo),x(fo),o&&t(Ds),o&&t(Ce),x(go),o&&t(ys),o&&t(L),x(_o),x(yo),x(et),x(tt),o&&t(ws),o&&t(Pe),x(wo),o&&t(xs),o&&t(R),x(xo),x(ko),x(nt),x(rt),o&&t(Ts),o&&t(Se),x(jo),o&&t(Es),o&&t(H),x($o),x(qo),x(st),x(it)}}}const E_={local:"detr",sections:[{local:"overview",title:"Overview"},{local:"transformers.models.detr.modeling_detr.DetrModelOutput",title:"DETR specific outputs"},{local:"transformers.DetrConfig",title:"DetrConfig"},{local:"transformers.DetrFeatureExtractor",title:"DetrFeatureExtractor"},{local:"transformers.DetrModel",title:"DetrModel"},{local:"transformers.DetrForObjectDetection",title:"DetrForObjectDetection"},{local:"transformers.DetrForSegmentation",title:"DetrForSegmentation"}],title:"DETR"};function F_(z){return u_(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class q_ extends h_{constructor(f){super();m_(this,f,F_,T_,p_,{})}}export{q_ as default,E_ as metadata};
